/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         smingparse
#define yylex           sminglex
#define yyerror         smingerror
#define yydebug         smingdebug
#define yynerrs         smingnerrs

/* First part of user prologue.  */
#line 17 "parser-sming.y"


#include <config.h>
    
#ifdef BACKEND_SMING


#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <limits.h>
#include <float.h>

#if defined(_MSC_VER)
#include <malloc.h>
#endif

#ifdef HAVE_WIN_H
#include "win.h"
#endif

#include "smi.h"
#include "error.h"
#include "parser-sming.h"
#include "scanner-sming.h"
#include "data.h"
#include "check.h"
#include "util.h"
    
#ifdef HAVE_DMALLOC_H
#include <dmalloc.h>
#endif


    
#define thisParserPtr      ((Parser *)parserPtr)
#define thisModulePtr     (((Parser *)parserPtr)->modulePtr)


    
/*
 * NOTE: The argument lvalp ist not really a void pointer. Unfortunately,
 * we don't know it better at this point. bison generated C code declares
 * YYSTYPE just a few lines below based on the `%union' declaration.
 */
extern int yylex(void *lvalp, Parser *parserPtr);



static char *typeIdentifier, *macroIdentifier, *identityIdentifier, 
	    *classIdentifier, *attributeIdentifier;
static char *importModulename = NULL;
static Type *typePtr = NULL;
static Macro *macroPtr = NULL;
static Identity *identityPtr = NULL;
static Class	*classPtr = NULL;
static Attribute *attributePtr = NULL;
static Event *eventPtr = NULL;
static SmiBasetype defaultBasetype = SMI_BASETYPE_UNKNOWN;
static NamedNumber *namedNumberPtr = NULL;
static int bitsFlag = 0; /* used to differentiate bits definition from enum*/
static int attributeFlag = 0; /* 
							   *Used to differentiate between attribute and
							   *and typedef to tie the type statement
							   *respectively to class or module.
							   */


#define SMI_EPOCH	631152000	/* 01 Jan 1990 00:00:00 */ 
 

static Type *
findType(char *spec, Parser *parserPtr, Module *modulePtr)
{
    Type *typePtr;
    Import *importPtr;
    char *module, *type;

    type = strstr(spec, "::");
    if (!type) {
	typePtr = findTypeByModuleAndName(modulePtr, spec);
	if (!typePtr) {
	    importPtr = findImportByName(spec, modulePtr);
	    if (importPtr) {
		typePtr = findTypeByModulenameAndName(importPtr->export.module,
						      spec);
	    }
	}
    } else {
	module = strtok(spec, ":");
	type = &type[2];
	typePtr = findTypeByModulenameAndName(module, type);
    }
    return typePtr;
}
 
 
static Identity *
findIdentity(char *spec, Parser *parserPtr, Module *modulePtr)
{
    Identity *identityPtr;
    Import *importPtr;
    char *module, *identity;

    identity = strstr(spec, "::");
    if (!identity) {
	identityPtr = findIdentityByModuleAndName(modulePtr, spec);
	if (!identityPtr) {
	    importPtr = findImportByName(spec, modulePtr);
	    if (importPtr) {
		identityPtr = findIdentityByModulenameAndName(importPtr->export.module,
						      spec);
	    }
	}
    } else {
	module = strtok(spec, ":");
	identity = &identity[2];
	identityPtr = findIdentityByModulenameAndName(module, identity);
    }
    return identityPtr;
}

static Class *
findClass(char *spec, Parser *parserPtr, Module *modulePtr)
{
    Class *classPtr;
    Import *importPtr;
    char *module, *class;

    class = strstr(spec, "::");
    if (!class) {
	classPtr = findClassByModuleAndName(modulePtr, spec);
	if (!classPtr) {
	    importPtr = findImportByName(spec, modulePtr);
	    if (importPtr) {
		classPtr = findClassByModulenameAndName(importPtr->export.module,
						      spec);
	    }
	}
    } else {
	module = strtok(spec, ":");
	class = &class[2];
	classPtr = findClassByModulenameAndName(module, class);
    }
    return classPtr;
}

static void
checkTypes(Parser *parserPtr, Module *modulePtr)
{
    Type *typePtr;
    
    for(typePtr = modulePtr->firstTypePtr;
	typePtr; typePtr = typePtr->nextPtr) {

	/*
	 * Complain about empty description clauses.
	 */

	if (! parserPtr->flags & SMI_FLAG_NODESCR
	    && (! typePtr->export.description
		|| ! typePtr->export.description[0])) {
	    smiPrintErrorAtLine(parserPtr, ERR_EMPTY_DESCRIPTION,
				typePtr->line, typePtr->export.name);
	}
	
	smiCheckNamedNumberRedefinition(parserPtr, typePtr);
	smiCheckNamedNumberSubtyping(parserPtr, typePtr);
    }
}



static time_t
checkDate(Parser *parserPtr, char *date)
{
    struct tm	tm;
    time_t	anytime;
    int		i, len;
    char	*p;

    memset(&tm, 0, sizeof(tm));
    anytime = 0;

    len = strlen(date);
    if (len == 10 || len == 16) {
	for (i = 0; i < len; i++) {
	    if (((i < 4 || i == 5 || i == 6 || i == 8 || i == 9 || i == 11
		  || i == 12 || i == 14 || i == 15) && ! isdigit((int)date[i]))
		|| ((i == 4 || i == 7) && date[i] != '-')
		|| (i == 10 && date[i] != ' ')
		|| (i == 13 && date[i] != ':')) {
		smiPrintError(parserPtr, ERR_DATE_CHARACTER, date);
		anytime = (time_t) -1;
		break;
	    }
	}
    } else {
	smiPrintError(parserPtr, ERR_DATE_LENGTH, date);
	anytime = (time_t) -1;
    }
    
    if (anytime == 0) {
	for (i = 0, p = date, tm.tm_year = 0; i < 4; i++, p++) {
	    tm.tm_year = tm.tm_year * 10 + (*p - '0');
	}
	p++;
	tm.tm_mon = (p[0]-'0') * 10 + (p[1]-'0');
	p += 3;
	tm.tm_mday = (p[0]-'0') * 10 + (p[1]-'0');
	p += 2;
	if (len == 16) {
	    p++;
	    tm.tm_hour = (p[0]-'0') * 10 + (p[1]-'0');
	    p += 3;
	    tm.tm_min = (p[0]-'0') * 10 + (p[1]-'0');
	}
	
	if (tm.tm_mon < 1 || tm.tm_mon > 12) {
	    smiPrintError(parserPtr, ERR_DATE_MONTH, date);
	}
	if (tm.tm_mday < 1 || tm.tm_mday > 31) {
	    smiPrintError(parserPtr, ERR_DATE_DAY, date);
	}
	if (tm.tm_hour < 0 || tm.tm_hour > 23) {
	    smiPrintError(parserPtr, ERR_DATE_HOUR, date);
	}
	if (tm.tm_min < 0 || tm.tm_min > 59) {
	    smiPrintError(parserPtr, ERR_DATE_MINUTES, date);
	}
	
	tm.tm_year -= 1900;
	tm.tm_mon -= 1;
	tm.tm_isdst = 0;

	anytime = timegm(&tm);

	if (anytime == (time_t) -1) {
	    smiPrintError(parserPtr, ERR_DATE_VALUE, date);
	} else {
	    if (anytime < SMI_EPOCH) {
		smiPrintError(parserPtr, ERR_DATE_IN_PAST, date);
	    }
	    if (anytime > time(NULL)) {
		smiPrintError(parserPtr, ERR_DATE_IN_FUTURE, date);
	    }
	}
    }
    
    return (anytime == (time_t) -1) ? 0 : anytime;
}

static char *hexToStr(char *hexStr, int len)
{
   union{
   	char ch;
   	long l;
   } hex2char;
   
   char* res =(char*)malloc(sizeof(char)*len/2+1);
   char* tmp =(char*)malloc(sizeof(char)*3);
   int i,j = 0;

   tmp[2]=0;
   for(i=2; i+1<len; i+=2)
   {
   	tmp[0]= hexStr[i];
   	tmp[1]= hexStr[i+1];
   	
   	hex2char.l = strtol(tmp,NULL,16);
   	res[j] = hex2char.ch;
   	
   	j++;
   }
   
   smiFree(tmp);
   
   res[j]=0;
   return res;
}

static void createBitsValue(SmiValue *valuePtr, Type *typePtr)
{
    List *bitsListPtr, *valueListPtr, *p, *pp, *nextPtr;
    int nBits, bit;
    
    if (valuePtr->basetype != SMI_BASETYPE_BITS)
	return;
	
	bitsListPtr = typePtr->listPtr;
	valueListPtr = (void *)valuePtr->value.ptr;
	for (nBits = 0, p = bitsListPtr; p; p = p->nextPtr) {
	    if (nBits < 1+((NamedNumber *)(p->ptr))->export.value.value.unsigned64) {
		nBits = 1+((NamedNumber *)(p->ptr))->export.value.value.unsigned64;
	    }
	}
	valuePtr->value.ptr = smiMalloc((nBits+7)/8);
	memset(valuePtr->value.ptr, 0, (nBits+7)/8);
	valuePtr->len = (nBits+7)/8;
	for (p = valueListPtr; p;) {
	    for (pp = bitsListPtr; pp; pp = pp->nextPtr) {
		if (!strcmp(p->ptr,
			    ((NamedNumber *)(pp->ptr))->export.name)) {
		    bit = (int)(((NamedNumber *)(pp->ptr))->export.value.value.unsigned64);
		    valuePtr->value.ptr[bit/8] |=
			1 << (7-(bit%8));
		}
	    }
	    smiFree(p->ptr);
	    nextPtr = p->nextPtr;
	    smiFree(p);
	    p = nextPtr;
	}
}

			    

#line 397 "parser-sming.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser-sming.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DOT = 3,                        /* DOT  */
  YYSYMBOL_DOT_DOT = 4,                    /* DOT_DOT  */
  YYSYMBOL_COLON_COLON = 5,                /* COLON_COLON  */
  YYSYMBOL_ucIdentifier = 6,               /* ucIdentifier  */
  YYSYMBOL_lcIdentifier = 7,               /* lcIdentifier  */
  YYSYMBOL_floatValue = 8,                 /* floatValue  */
  YYSYMBOL_textSegment = 9,                /* textSegment  */
  YYSYMBOL_decimalNumber = 10,             /* decimalNumber  */
  YYSYMBOL_hexadecimalNumber = 11,         /* hexadecimalNumber  */
  YYSYMBOL_OID = 12,                       /* OID  */
  YYSYMBOL_moduleKeyword = 13,             /* moduleKeyword  */
  YYSYMBOL_importKeyword = 14,             /* importKeyword  */
  YYSYMBOL_revisionKeyword = 15,           /* revisionKeyword  */
  YYSYMBOL_identityKeyword = 16,           /* identityKeyword  */
  YYSYMBOL_oidKeyword = 17,                /* oidKeyword  */
  YYSYMBOL_dateKeyword = 18,               /* dateKeyword  */
  YYSYMBOL_organizationKeyword = 19,       /* organizationKeyword  */
  YYSYMBOL_contactKeyword = 20,            /* contactKeyword  */
  YYSYMBOL_descriptionKeyword = 21,        /* descriptionKeyword  */
  YYSYMBOL_referenceKeyword = 22,          /* referenceKeyword  */
  YYSYMBOL_extensionKeyword = 23,          /* extensionKeyword  */
  YYSYMBOL_typedefKeyword = 24,            /* typedefKeyword  */
  YYSYMBOL_typeKeyword = 25,               /* typeKeyword  */
  YYSYMBOL_formatKeyword = 26,             /* formatKeyword  */
  YYSYMBOL_unitsKeyword = 27,              /* unitsKeyword  */
  YYSYMBOL_statusKeyword = 28,             /* statusKeyword  */
  YYSYMBOL_accessKeyword = 29,             /* accessKeyword  */
  YYSYMBOL_defaultKeyword = 30,            /* defaultKeyword  */
  YYSYMBOL_impliedKeyword = 31,            /* impliedKeyword  */
  YYSYMBOL_indexKeyword = 32,              /* indexKeyword  */
  YYSYMBOL_augmentsKeyword = 33,           /* augmentsKeyword  */
  YYSYMBOL_reordersKeyword = 34,           /* reordersKeyword  */
  YYSYMBOL_sparseKeyword = 35,             /* sparseKeyword  */
  YYSYMBOL_expandsKeyword = 36,            /* expandsKeyword  */
  YYSYMBOL_createKeyword = 37,             /* createKeyword  */
  YYSYMBOL_membersKeyword = 38,            /* membersKeyword  */
  YYSYMBOL_objectsKeyword = 39,            /* objectsKeyword  */
  YYSYMBOL_mandatoryKeyword = 40,          /* mandatoryKeyword  */
  YYSYMBOL_optionalKeyword = 41,           /* optionalKeyword  */
  YYSYMBOL_refineKeyword = 42,             /* refineKeyword  */
  YYSYMBOL_abnfKeyword = 43,               /* abnfKeyword  */
  YYSYMBOL_OctetStringKeyword = 44,        /* OctetStringKeyword  */
  YYSYMBOL_ObjectIdentifierKeyword = 45,   /* ObjectIdentifierKeyword  */
  YYSYMBOL_Integer32Keyword = 46,          /* Integer32Keyword  */
  YYSYMBOL_Unsigned32Keyword = 47,         /* Unsigned32Keyword  */
  YYSYMBOL_Integer64Keyword = 48,          /* Integer64Keyword  */
  YYSYMBOL_Unsigned64Keyword = 49,         /* Unsigned64Keyword  */
  YYSYMBOL_Float32Keyword = 50,            /* Float32Keyword  */
  YYSYMBOL_Float64Keyword = 51,            /* Float64Keyword  */
  YYSYMBOL_Float128Keyword = 52,           /* Float128Keyword  */
  YYSYMBOL_BitsKeyword = 53,               /* BitsKeyword  */
  YYSYMBOL_EnumerationKeyword = 54,        /* EnumerationKeyword  */
  YYSYMBOL_currentKeyword = 55,            /* currentKeyword  */
  YYSYMBOL_deprecatedKeyword = 56,         /* deprecatedKeyword  */
  YYSYMBOL_obsoleteKeyword = 57,           /* obsoleteKeyword  */
  YYSYMBOL_readonlyKeyword = 58,           /* readonlyKeyword  */
  YYSYMBOL_readwriteKeyword = 59,          /* readwriteKeyword  */
  YYSYMBOL_parentKeyword = 60,             /* parentKeyword  */
  YYSYMBOL_classKeyword = 61,              /* classKeyword  */
  YYSYMBOL_extendsKeyword = 62,            /* extendsKeyword  */
  YYSYMBOL_attributeKeyword = 63,          /* attributeKeyword  */
  YYSYMBOL_uniqueKeyword = 64,             /* uniqueKeyword  */
  YYSYMBOL_eventKeyword = 65,              /* eventKeyword  */
  YYSYMBOL_PointerKeyword = 66,            /* PointerKeyword  */
  YYSYMBOL_eventonlyKeyword = 67,          /* eventonlyKeyword  */
  YYSYMBOL_neginfKeyword = 68,             /* neginfKeyword  */
  YYSYMBOL_posinfKeyword = 69,             /* posinfKeyword  */
  YYSYMBOL_snanKeyword = 70,               /* snanKeyword  */
  YYSYMBOL_qnanKeyword = 71,               /* qnanKeyword  */
  YYSYMBOL_72_ = 72,                       /* '{'  */
  YYSYMBOL_73_ = 73,                       /* '}'  */
  YYSYMBOL_74_ = 74,                       /* ';'  */
  YYSYMBOL_75_ = 75,                       /* '('  */
  YYSYMBOL_76_ = 76,                       /* ')'  */
  YYSYMBOL_77_ = 77,                       /* '|'  */
  YYSYMBOL_78_ = 78,                       /* ','  */
  YYSYMBOL_79_ = 79,                       /* '-'  */
  YYSYMBOL_YYACCEPT = 80,                  /* $accept  */
  YYSYMBOL_smingFile = 81,                 /* smingFile  */
  YYSYMBOL_moduleStatement_optsep_0n = 82, /* moduleStatement_optsep_0n  */
  YYSYMBOL_moduleStatement_optsep_1n = 83, /* moduleStatement_optsep_1n  */
  YYSYMBOL_moduleStatement_optsep = 84,    /* moduleStatement_optsep  */
  YYSYMBOL_moduleStatement = 85,           /* moduleStatement  */
  YYSYMBOL_86_1 = 86,                      /* $@1  */
  YYSYMBOL_87_2 = 87,                      /* $@2  */
  YYSYMBOL_88_3 = 88,                      /* $@3  */
  YYSYMBOL_89_4 = 89,                      /* $@4  */
  YYSYMBOL_90_5 = 90,                      /* $@5  */
  YYSYMBOL_extensionStatement_stmtsep_0n = 91, /* extensionStatement_stmtsep_0n  */
  YYSYMBOL_extensionStatement_stmtsep_1n = 92, /* extensionStatement_stmtsep_1n  */
  YYSYMBOL_extensionStatement_stmtsep = 93, /* extensionStatement_stmtsep  */
  YYSYMBOL_extensionStatement = 94,        /* extensionStatement  */
  YYSYMBOL_95_6 = 95,                      /* $@6  */
  YYSYMBOL_96_7 = 96,                      /* $@7  */
  YYSYMBOL_97_8 = 97,                      /* $@8  */
  YYSYMBOL_98_9 = 98,                      /* $@9  */
  YYSYMBOL_99_10 = 99,                     /* $@10  */
  YYSYMBOL_typedefStatement_stmtsep_0n = 100, /* typedefStatement_stmtsep_0n  */
  YYSYMBOL_typedefStatement_stmtsep_1n = 101, /* typedefStatement_stmtsep_1n  */
  YYSYMBOL_typedefStatement_stmtsep = 102, /* typedefStatement_stmtsep  */
  YYSYMBOL_typedefStatement = 103,         /* typedefStatement  */
  YYSYMBOL_104_11 = 104,                   /* $@11  */
  YYSYMBOL_105_12 = 105,                   /* $@12  */
  YYSYMBOL_106_13 = 106,                   /* $@13  */
  YYSYMBOL_107_14 = 107,                   /* $@14  */
  YYSYMBOL_108_15 = 108,                   /* $@15  */
  YYSYMBOL_109_16 = 109,                   /* $@16  */
  YYSYMBOL_110_17 = 110,                   /* $@17  */
  YYSYMBOL_111_18 = 111,                   /* $@18  */
  YYSYMBOL_classStatement_stmtsep_0n = 112, /* classStatement_stmtsep_0n  */
  YYSYMBOL_classStatement_stmtsep_1n = 113, /* classStatement_stmtsep_1n  */
  YYSYMBOL_classStatement_stmtsep = 114,   /* classStatement_stmtsep  */
  YYSYMBOL_classStatement = 115,           /* classStatement  */
  YYSYMBOL_116_19 = 116,                   /* $@19  */
  YYSYMBOL_117_20 = 117,                   /* $@20  */
  YYSYMBOL_118_21 = 118,                   /* $@21  */
  YYSYMBOL_119_22 = 119,                   /* $@22  */
  YYSYMBOL_120_23 = 120,                   /* $@23  */
  YYSYMBOL_121_24 = 121,                   /* $@24  */
  YYSYMBOL_attributeStatement_stmtsep_0n = 122, /* attributeStatement_stmtsep_0n  */
  YYSYMBOL_attributeStatement_stmtsep_1n = 123, /* attributeStatement_stmtsep_1n  */
  YYSYMBOL_attributeStatement_stmtsep = 124, /* attributeStatement_stmtsep  */
  YYSYMBOL_attributeStatement = 125,       /* attributeStatement  */
  YYSYMBOL_126_25 = 126,                   /* $@25  */
  YYSYMBOL_127_26 = 127,                   /* $@26  */
  YYSYMBOL_128_27 = 128,                   /* $@27  */
  YYSYMBOL_129_28 = 129,                   /* $@28  */
  YYSYMBOL_130_29 = 130,                   /* $@29  */
  YYSYMBOL_131_30 = 131,                   /* $@30  */
  YYSYMBOL_132_31 = 132,                   /* $@31  */
  YYSYMBOL_133_32 = 133,                   /* $@32  */
  YYSYMBOL_134_33 = 134,                   /* $@33  */
  YYSYMBOL_eventStatement_stmtsep_0n = 135, /* eventStatement_stmtsep_0n  */
  YYSYMBOL_eventStatement_stmtsep_1n = 136, /* eventStatement_stmtsep_1n  */
  YYSYMBOL_eventStatement_stmtsep = 137,   /* eventStatement_stmtsep  */
  YYSYMBOL_eventStatement = 138,           /* eventStatement  */
  YYSYMBOL_139_34 = 139,                   /* $@34  */
  YYSYMBOL_140_35 = 140,                   /* $@35  */
  YYSYMBOL_141_36 = 141,                   /* $@36  */
  YYSYMBOL_142_37 = 142,                   /* $@37  */
  YYSYMBOL_importStatement_stmtsep_0n = 143, /* importStatement_stmtsep_0n  */
  YYSYMBOL_importStatement_stmtsep_1n = 144, /* importStatement_stmtsep_1n  */
  YYSYMBOL_importStatement_stmtsep = 145,  /* importStatement_stmtsep  */
  YYSYMBOL_importStatement = 146,          /* importStatement  */
  YYSYMBOL_147_38 = 147,                   /* $@38  */
  YYSYMBOL_148_39 = 148,                   /* $@39  */
  YYSYMBOL_revisionStatement_stmtsep_0n = 149, /* revisionStatement_stmtsep_0n  */
  YYSYMBOL_revisionStatement_stmtsep_1n = 150, /* revisionStatement_stmtsep_1n  */
  YYSYMBOL_revisionStatement_stmtsep = 151, /* revisionStatement_stmtsep  */
  YYSYMBOL_revisionStatement = 152,        /* revisionStatement  */
  YYSYMBOL_identityStatement_stmtsep_0n = 153, /* identityStatement_stmtsep_0n  */
  YYSYMBOL_identityStatement_stmtsep_1n = 154, /* identityStatement_stmtsep_1n  */
  YYSYMBOL_identityStatement_stmtsep = 155, /* identityStatement_stmtsep  */
  YYSYMBOL_identityStatement = 156,        /* identityStatement  */
  YYSYMBOL_157_40 = 157,                   /* $@40  */
  YYSYMBOL_158_41 = 158,                   /* $@41  */
  YYSYMBOL_159_42 = 159,                   /* $@42  */
  YYSYMBOL_160_43 = 160,                   /* $@43  */
  YYSYMBOL_161_44 = 161,                   /* $@44  */
  YYSYMBOL_typedefTypeStatement = 162,     /* typedefTypeStatement  */
  YYSYMBOL_attributeTypeStatement = 163,   /* attributeTypeStatement  */
  YYSYMBOL_dateStatement = 164,            /* dateStatement  */
  YYSYMBOL_organizationStatement = 165,    /* organizationStatement  */
  YYSYMBOL_contactStatement = 166,         /* contactStatement  */
  YYSYMBOL_formatStatement_stmtsep_01 = 167, /* formatStatement_stmtsep_01  */
  YYSYMBOL_formatStatement = 168,          /* formatStatement  */
  YYSYMBOL_unitsStatement_stmtsep_01 = 169, /* unitsStatement_stmtsep_01  */
  YYSYMBOL_unitsStatement = 170,           /* unitsStatement  */
  YYSYMBOL_statusStatement_stmtsep_01 = 171, /* statusStatement_stmtsep_01  */
  YYSYMBOL_statusStatement = 172,          /* statusStatement  */
  YYSYMBOL_uniqueStatement_stmtsep_01 = 173, /* uniqueStatement_stmtsep_01  */
  YYSYMBOL_uniqueStatement = 174,          /* uniqueStatement  */
  YYSYMBOL_uniqueSpec = 175,               /* uniqueSpec  */
  YYSYMBOL_extendsStatement_stmtsep_01 = 176, /* extendsStatement_stmtsep_01  */
  YYSYMBOL_extendsStatement = 177,         /* extendsStatement  */
  YYSYMBOL_defaultStatement_stmtsep_01 = 178, /* defaultStatement_stmtsep_01  */
  YYSYMBOL_defaultStatement = 179,         /* defaultStatement  */
  YYSYMBOL_accessStatement_stmtsep_01 = 180, /* accessStatement_stmtsep_01  */
  YYSYMBOL_accessStatement = 181,          /* accessStatement  */
  YYSYMBOL_access = 182,                   /* access  */
  YYSYMBOL_parentStatement_stmtsep_01 = 183, /* parentStatement_stmtsep_01  */
  YYSYMBOL_parentStatement = 184,          /* parentStatement  */
  YYSYMBOL_descriptionStatement_stmtsep_01 = 185, /* descriptionStatement_stmtsep_01  */
  YYSYMBOL_descriptionStatement = 186,     /* descriptionStatement  */
  YYSYMBOL_referenceStatement_stmtsep_01 = 187, /* referenceStatement_stmtsep_01  */
  YYSYMBOL_referenceStatement = 188,       /* referenceStatement  */
  YYSYMBOL_abnfStatement_stmtsep_01 = 189, /* abnfStatement_stmtsep_01  */
  YYSYMBOL_abnfStatement = 190,            /* abnfStatement  */
  YYSYMBOL_refinedBaseType_refinedType = 191, /* refinedBaseType_refinedType  */
  YYSYMBOL_attribute_refinedBaseType_refinedType = 192, /* attribute_refinedBaseType_refinedType  */
  YYSYMBOL_refinedBaseType = 193,          /* refinedBaseType  */
  YYSYMBOL_194_45 = 194,                   /* $@45  */
  YYSYMBOL_attribute_refinedBaseType = 195, /* attribute_refinedBaseType  */
  YYSYMBOL_196_46 = 196,                   /* $@46  */
  YYSYMBOL_refinedType = 197,              /* refinedType  */
  YYSYMBOL_attribute_refinedType = 198,    /* attribute_refinedType  */
  YYSYMBOL_optsep_anySpec_01 = 199,        /* optsep_anySpec_01  */
  YYSYMBOL_anySpec = 200,                  /* anySpec  */
  YYSYMBOL_optsep_numberSpec_01 = 201,     /* optsep_numberSpec_01  */
  YYSYMBOL_numberSpec = 202,               /* numberSpec  */
  YYSYMBOL_furtherNumberElement_0n = 203,  /* furtherNumberElement_0n  */
  YYSYMBOL_furtherNumberElement_1n = 204,  /* furtherNumberElement_1n  */
  YYSYMBOL_furtherNumberElement = 205,     /* furtherNumberElement  */
  YYSYMBOL_numberElement = 206,            /* numberElement  */
  YYSYMBOL_numberUpperLimit_01 = 207,      /* numberUpperLimit_01  */
  YYSYMBOL_numberUpperLimit = 208,         /* numberUpperLimit  */
  YYSYMBOL_optsep_floatSpec_01 = 209,      /* optsep_floatSpec_01  */
  YYSYMBOL_floatSpec = 210,                /* floatSpec  */
  YYSYMBOL_furtherFloatElement_0n = 211,   /* furtherFloatElement_0n  */
  YYSYMBOL_furtherFloatElement_1n = 212,   /* furtherFloatElement_1n  */
  YYSYMBOL_furtherFloatElement = 213,      /* furtherFloatElement  */
  YYSYMBOL_floatElement = 214,             /* floatElement  */
  YYSYMBOL_floatUpperLimit_01 = 215,       /* floatUpperLimit_01  */
  YYSYMBOL_floatUpperLimit = 216,          /* floatUpperLimit  */
  YYSYMBOL_specialFloatValue = 217,        /* specialFloatValue  */
  YYSYMBOL_optsep_pointerRestr_01 = 218,   /* optsep_pointerRestr_01  */
  YYSYMBOL_pointerRestr = 219,             /* pointerRestr  */
  YYSYMBOL_bitsOrEnumerationSpec = 220,    /* bitsOrEnumerationSpec  */
  YYSYMBOL_bitsOrEnumerationList = 221,    /* bitsOrEnumerationList  */
  YYSYMBOL_furtherBitsOrEnumerationItem_0n = 222, /* furtherBitsOrEnumerationItem_0n  */
  YYSYMBOL_furtherBitsOrEnumerationItem_1n = 223, /* furtherBitsOrEnumerationItem_1n  */
  YYSYMBOL_furtherBitsOrEnumerationItem = 224, /* furtherBitsOrEnumerationItem  */
  YYSYMBOL_bitsOrEnumerationItem = 225,    /* bitsOrEnumerationItem  */
  YYSYMBOL_identifierList = 226,           /* identifierList  */
  YYSYMBOL_furtherIdentifier_0n = 227,     /* furtherIdentifier_0n  */
  YYSYMBOL_furtherIdentifier_1n = 228,     /* furtherIdentifier_1n  */
  YYSYMBOL_furtherIdentifier = 229,        /* furtherIdentifier  */
  YYSYMBOL_bitsValue = 230,                /* bitsValue  */
  YYSYMBOL_bitsList = 231,                 /* bitsList  */
  YYSYMBOL_furtherLcIdentifier_0n = 232,   /* furtherLcIdentifier_0n  */
  YYSYMBOL_furtherLcIdentifier_1n = 233,   /* furtherLcIdentifier_1n  */
  YYSYMBOL_furtherLcIdentifier = 234,      /* furtherLcIdentifier  */
  YYSYMBOL_identifier = 235,               /* identifier  */
  YYSYMBOL_qucIdentifier = 236,            /* qucIdentifier  */
  YYSYMBOL_qlcIdentifier = 237,            /* qlcIdentifier  */
  YYSYMBOL_text = 238,                     /* text  */
  YYSYMBOL_optsep_textSegment_0n = 239,    /* optsep_textSegment_0n  */
  YYSYMBOL_optsep_textSegment_1n = 240,    /* optsep_textSegment_1n  */
  YYSYMBOL_optsep_textSegment = 241,       /* optsep_textSegment  */
  YYSYMBOL_date = 242,                     /* date  */
  YYSYMBOL_format = 243,                   /* format  */
  YYSYMBOL_units = 244,                    /* units  */
  YYSYMBOL_anyValue = 245,                 /* anyValue  */
  YYSYMBOL_qOID = 246,                     /* qOID  */
  YYSYMBOL_status = 247,                   /* status  */
  YYSYMBOL_number = 248,                   /* number  */
  YYSYMBOL_negativeNumber = 249,           /* negativeNumber  */
  YYSYMBOL_signedNumber = 250,             /* signedNumber  */
  YYSYMBOL_optsep_comma_01 = 251,          /* optsep_comma_01  */
  YYSYMBOL_sep = 252,                      /* sep  */
  YYSYMBOL_optsep = 253,                   /* optsep  */
  YYSYMBOL_stmtsep = 254                   /* stmtsep  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   542

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  80
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  175
/* YYNRULES -- Number of rules.  */
#define YYNRULES  271
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  545

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   326


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      75,    76,     2,     2,    78,    79,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    74,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,    77,    73,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   607,   607,   618,   621,   627,   631,   646,   661,   691,
     698,   705,   712,   660,   732,   735,   745,   749,   765,   780,
     789,   795,   802,   809,   779,   823,   826,   836,   840,   856,
     871,   885,   905,   928,   937,   943,   949,   956,   870,   974,
     977,   987,   991,  1007,  1022,  1038,  1044,  1087,  1093,  1100,
    1021,  1114,  1117,  1127,  1131,  1147,  1162,  1176,  1187,  1207,
    1224,  1240,  1252,  1257,  1262,  1161,  1275,  1278,  1288,  1292,
    1308,  1323,  1329,  1334,  1339,  1322,  1351,  1354,  1360,  1364,
    1379,  1394,  1399,  1393,  1426,  1429,  1435,  1439,  1454,  1468,
    1478,  1481,  1491,  1495,  1511,  1526,  1534,  1540,  1546,  1553,
    1525,  1564,  1570,  1576,  1582,  1588,  1595,  1598,  1604,  1611,
    1614,  1620,  1627,  1630,  1636,  1643,  1646,  1652,  1658,  1666,
    1678,  1681,  1687,  1698,  1701,  1707,  1714,  1717,  1723,  1729,
    1733,  1737,  1744,  1747,  1753,  1763,  1766,  1772,  1779,  1782,
    1788,  1795,  1798,  1804,  1812,  1816,  1822,  1826,  1833,  1848,
    1852,  1867,  1882,  1897,  1912,  1927,  1942,  1957,  1968,  1984,
    1983,  2012,  2024,  2030,  2043,  2056,  2069,  2082,  2095,  2108,
    2121,  2130,  2144,  2143,  2169,  2183,  2216,  2219,  2225,  2229,
    2236,  2239,  2245,  2255,  2258,  2264,  2270,  2283,  2289,  2304,
    2307,  2313,  2320,  2323,  2329,  2339,  2342,  2348,  2354,  2367,
    2373,  2390,  2393,  2399,  2406,  2410,  2414,  2418,  2425,  2428,
    2437,  2443,  2449,  2459,  2462,  2468,  2474,  2489,  2495,  2503,
    2512,  2515,  2521,  2527,  2540,  2546,  2552,  2556,  2566,  2569,
    2575,  2581,  2594,  2600,  2604,  2610,  2621,  2627,  2636,  2642,
    2662,  2665,  2671,  2675,  2685,  2691,  2697,  2703,  2716,  2736,
    2774,  2794,  2831,  2879,  2920,  2961,  2974,  3007,  3021,  3030,
    3037,  3041,  3045,  3051,  3057,  3065,  3078,  3082,  3093,  3100,
    3106,  3112
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DOT", "DOT_DOT",
  "COLON_COLON", "ucIdentifier", "lcIdentifier", "floatValue",
  "textSegment", "decimalNumber", "hexadecimalNumber", "OID",
  "moduleKeyword", "importKeyword", "revisionKeyword", "identityKeyword",
  "oidKeyword", "dateKeyword", "organizationKeyword", "contactKeyword",
  "descriptionKeyword", "referenceKeyword", "extensionKeyword",
  "typedefKeyword", "typeKeyword", "formatKeyword", "unitsKeyword",
  "statusKeyword", "accessKeyword", "defaultKeyword", "impliedKeyword",
  "indexKeyword", "augmentsKeyword", "reordersKeyword", "sparseKeyword",
  "expandsKeyword", "createKeyword", "membersKeyword", "objectsKeyword",
  "mandatoryKeyword", "optionalKeyword", "refineKeyword", "abnfKeyword",
  "OctetStringKeyword", "ObjectIdentifierKeyword", "Integer32Keyword",
  "Unsigned32Keyword", "Integer64Keyword", "Unsigned64Keyword",
  "Float32Keyword", "Float64Keyword", "Float128Keyword", "BitsKeyword",
  "EnumerationKeyword", "currentKeyword", "deprecatedKeyword",
  "obsoleteKeyword", "readonlyKeyword", "readwriteKeyword",
  "parentKeyword", "classKeyword", "extendsKeyword", "attributeKeyword",
  "uniqueKeyword", "eventKeyword", "PointerKeyword", "eventonlyKeyword",
  "neginfKeyword", "posinfKeyword", "snanKeyword", "qnanKeyword", "'{'",
  "'}'", "';'", "'('", "')'", "'|'", "','", "'-'", "$accept", "smingFile",
  "moduleStatement_optsep_0n", "moduleStatement_optsep_1n",
  "moduleStatement_optsep", "moduleStatement", "$@1", "$@2", "$@3", "$@4",
  "$@5", "extensionStatement_stmtsep_0n", "extensionStatement_stmtsep_1n",
  "extensionStatement_stmtsep", "extensionStatement", "$@6", "$@7", "$@8",
  "$@9", "$@10", "typedefStatement_stmtsep_0n",
  "typedefStatement_stmtsep_1n", "typedefStatement_stmtsep",
  "typedefStatement", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16",
  "$@17", "$@18", "classStatement_stmtsep_0n", "classStatement_stmtsep_1n",
  "classStatement_stmtsep", "classStatement", "$@19", "$@20", "$@21",
  "$@22", "$@23", "$@24", "attributeStatement_stmtsep_0n",
  "attributeStatement_stmtsep_1n", "attributeStatement_stmtsep",
  "attributeStatement", "$@25", "$@26", "$@27", "$@28", "$@29", "$@30",
  "$@31", "$@32", "$@33", "eventStatement_stmtsep_0n",
  "eventStatement_stmtsep_1n", "eventStatement_stmtsep", "eventStatement",
  "$@34", "$@35", "$@36", "$@37", "importStatement_stmtsep_0n",
  "importStatement_stmtsep_1n", "importStatement_stmtsep",
  "importStatement", "$@38", "$@39", "revisionStatement_stmtsep_0n",
  "revisionStatement_stmtsep_1n", "revisionStatement_stmtsep",
  "revisionStatement", "identityStatement_stmtsep_0n",
  "identityStatement_stmtsep_1n", "identityStatement_stmtsep",
  "identityStatement", "$@40", "$@41", "$@42", "$@43", "$@44",
  "typedefTypeStatement", "attributeTypeStatement", "dateStatement",
  "organizationStatement", "contactStatement",
  "formatStatement_stmtsep_01", "formatStatement",
  "unitsStatement_stmtsep_01", "unitsStatement",
  "statusStatement_stmtsep_01", "statusStatement",
  "uniqueStatement_stmtsep_01", "uniqueStatement", "uniqueSpec",
  "extendsStatement_stmtsep_01", "extendsStatement",
  "defaultStatement_stmtsep_01", "defaultStatement",
  "accessStatement_stmtsep_01", "accessStatement", "access",
  "parentStatement_stmtsep_01", "parentStatement",
  "descriptionStatement_stmtsep_01", "descriptionStatement",
  "referenceStatement_stmtsep_01", "referenceStatement",
  "abnfStatement_stmtsep_01", "abnfStatement",
  "refinedBaseType_refinedType", "attribute_refinedBaseType_refinedType",
  "refinedBaseType", "$@45", "attribute_refinedBaseType", "$@46",
  "refinedType", "attribute_refinedType", "optsep_anySpec_01", "anySpec",
  "optsep_numberSpec_01", "numberSpec", "furtherNumberElement_0n",
  "furtherNumberElement_1n", "furtherNumberElement", "numberElement",
  "numberUpperLimit_01", "numberUpperLimit", "optsep_floatSpec_01",
  "floatSpec", "furtherFloatElement_0n", "furtherFloatElement_1n",
  "furtherFloatElement", "floatElement", "floatUpperLimit_01",
  "floatUpperLimit", "specialFloatValue", "optsep_pointerRestr_01",
  "pointerRestr", "bitsOrEnumerationSpec", "bitsOrEnumerationList",
  "furtherBitsOrEnumerationItem_0n", "furtherBitsOrEnumerationItem_1n",
  "furtherBitsOrEnumerationItem", "bitsOrEnumerationItem",
  "identifierList", "furtherIdentifier_0n", "furtherIdentifier_1n",
  "furtherIdentifier", "bitsValue", "bitsList", "furtherLcIdentifier_0n",
  "furtherLcIdentifier_1n", "furtherLcIdentifier", "identifier",
  "qucIdentifier", "qlcIdentifier", "text", "optsep_textSegment_0n",
  "optsep_textSegment_1n", "optsep_textSegment", "date", "format", "units",
  "anyValue", "qOID", "status", "number", "negativeNumber", "signedNumber",
  "optsep_comma_01", "sep", "optsep", "stmtsep", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-391)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-271)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -391,    11,     1,  -391,  -391,  -391,     1,  -391,  -391,    35,
    -391,  -391,  -391,  -391,   -54,  -391,    30,  -391,    34,    30,
    -391,  -391,    51,  -391,  -391,  -391,  -391,  -391,    50,  -391,
    -391,    54,  -391,    44,   -10,  -391,    54,  -391,    57,    -7,
    -391,  -391,  -391,  -391,  -391,  -391,    50,  -391,    40,  -391,
      47,  -391,  -391,  -391,     9,    -3,  -391,  -391,  -391,  -391,
       9,  -391,    10,  -391,    50,  -391,     2,  -391,  -391,  -391,
    -391,    60,  -391,    40,    15,  -391,  -391,  -391,    18,  -391,
    -391,    50,    64,  -391,  -391,  -391,  -391,    70,    64,  -391,
    -391,    22,    27,  -391,    67,    70,  -391,  -391,  -391,  -391,
    -391,  -391,    90,  -391,    78,    67,  -391,  -391,  -391,  -391,
      85,  -391,    97,  -391,    45,    78,  -391,  -391,  -391,  -391,
    -391,  -391,  -391,  -391,   103,  -391,    37,    45,  -391,  -391,
    -391,  -391,   104,    47,    42,  -391,  -391,   109,  -391,  -391,
    -391,  -391,  -391,  -391,  -391,    46,  -391,  -391,    43,    52,
      55,    88,  -391,    48,  -391,  -391,  -391,  -391,  -391,  -391,
    -391,    59,  -391,    58,    53,    -5,    47,  -391,  -391,  -391,
    -391,    98,  -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,
     117,    88,  -391,  -391,  -391,    69,    62,    60,  -391,  -391,
    -391,   447,  -391,  -391,  -391,  -391,  -391,  -391,    63,    47,
     124,    65,  -391,    65,    65,    65,    65,    65,    65,    65,
    -391,    66,    65,  -391,  -391,  -391,    65,   102,   128,    76,
    -391,   100,  -391,  -391,   138,  -391,    74,  -391,  -391,  -391,
    -391,  -391,    75,  -391,  -391,    66,  -391,  -391,  -391,    77,
      79,  -391,    83,  -391,  -391,  -391,  -391,  -391,    87,    76,
    -391,  -391,  -391,  -391,  -391,    60,  -391,  -391,  -391,  -391,
    -391,  -391,   152,  -391,  -391,  -391,  -391,  -391,  -391,  -391,
     386,   134,  -391,    89,   154,  -391,  -391,  -391,  -391,  -391,
      50,    92,  -391,  -391,     5,   159,  -391,  -391,     9,    49,
      12,   157,  -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,
    -391,  -391,    25,  -391,  -391,  -391,  -391,  -391,  -391,  -391,
    -391,  -391,  -391,  -391,    93,   106,  -391,  -391,  -391,    99,
    -391,  -391,   163,   101,  -391,  -391,   171,   171,   101,   107,
     105,  -391,     9,  -391,   108,   174,  -391,    17,   177,  -391,
    -391,   111,   178,   164,  -391,  -391,   183,  -391,    88,   106,
    -391,  -391,   118,   119,  -391,  -391,  -391,   101,  -391,   120,
    -391,  -391,   190,  -391,  -391,   191,  -391,   101,  -391,   121,
    -391,  -391,  -391,  -391,  -391,   189,   125,  -391,  -391,     9,
    -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,   130,     9,
     127,  -391,   193,  -391,  -391,  -391,  -391,  -391,   131,   135,
    -391,  -391,  -391,  -391,   139,  -391,  -391,     5,   152,  -391,
    -391,     9,  -391,   126,   141,   132,   201,    88,  -391,  -391,
    -391,  -391,  -391,    47,  -391,  -391,     5,     5,   206,  -391,
     159,  -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,
    -391,   194,  -391,   144,  -391,  -391,  -391,  -391,  -391,  -391,
     145,   213,   148,    47,  -391,  -391,  -391,   151,    60,  -391,
    -391,  -391,  -391,   475,   195,  -391,  -391,    60,    65,  -391,
      65,    65,    65,    65,    65,    65,    65,  -391,    66,    65,
    -391,  -391,  -391,    65,  -391,  -391,  -391,    88,   153,  -391,
    -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,    66,  -391,
    -391,   155,  -391,   -19,   102,  -391,  -391,  -391,   160,  -391,
    -391,  -391,  -391,  -391,  -391,  -391,    47,   158,  -391,   161,
     134,  -391,  -391,   166,  -391,  -391,    60,  -391,   164,  -391,
    -391,   168,    88,  -391,  -391,   169,    47,  -391,  -391,    60,
    -391,   172,  -391,   173,  -391
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     270,     0,     3,     1,   269,     2,     4,     5,   270,     0,
       6,     7,     8,   270,     0,   271,    76,   269,     0,    77,
      78,   271,     0,   269,   271,    79,    80,    81,     0,     9,
     270,   240,   270,     0,     0,   239,   241,   242,     0,     0,
     269,   271,   270,   243,   244,   104,     0,    10,     0,   270,
       0,   233,   234,    82,   220,     0,   269,   271,   270,   268,
     221,   222,     0,   105,     0,    11,     0,   219,   223,   270,
     270,   138,   270,     0,     0,   269,    12,   271,     0,   224,
     137,     0,    84,   139,    83,   270,   270,    14,    85,    86,
     271,     0,     0,   269,    90,    15,    16,   271,    87,    88,
     140,   271,     0,   269,    25,    91,    92,   271,    17,    18,
       0,    19,     0,   269,    39,    26,    27,   271,    93,    94,
     269,   271,   270,    95,     0,   269,     0,    40,    41,   271,
      28,    29,     0,     0,     0,   270,    30,     0,   270,    42,
      43,   245,   270,   271,   271,     0,   270,    44,     0,     0,
       0,   112,   271,     0,   270,    13,   103,   270,   269,    20,
     271,   132,   271,     0,     0,     0,   135,   113,   269,    96,
     271,     0,   271,    89,   260,   261,   262,   270,    21,   271,
       0,   112,   133,   269,   271,   120,     0,   138,   136,   270,
      97,     0,    31,   269,    45,   271,   114,    22,     0,   135,
     236,   180,   149,   180,   180,   180,   180,   192,   192,   192,
     159,     0,   208,   270,   144,   145,   176,   123,     0,    51,
     121,   141,   134,    98,     0,   148,     0,   150,   151,   152,
     153,   154,     0,   155,   156,     0,   270,   158,   157,     0,
       0,   174,     0,   269,    32,   271,   270,   269,   115,    52,
      53,   271,   269,    23,   271,   138,   235,   270,   181,   270,
     193,   160,     0,   270,   209,   101,   270,   177,   178,   179,
       0,   106,   124,     0,     0,   269,    46,   271,    54,    55,
       0,     0,   142,    99,     0,     0,   270,   270,   213,     0,
       0,     0,   238,   252,   249,   251,   259,   204,   205,   207,
     206,   270,     0,   254,   248,   256,   255,   270,   257,   269,
      33,   271,   122,    56,     0,    66,   116,   270,   270,     0,
     264,   263,     0,   183,   266,   267,   189,   201,   195,     0,
       0,   268,   214,   215,     0,     0,   270,     0,   268,   253,
     250,     0,     0,   109,   107,   270,   268,   269,   112,    67,
      68,   271,     0,     0,   270,   265,   270,   184,   185,     0,
     188,   190,     0,   200,   202,     0,   270,   196,   197,     0,
     270,   211,   212,   216,   270,     0,     0,   237,   258,   228,
     270,   226,   125,   246,   270,   269,    34,   271,     0,   228,
       0,   118,     0,    47,    69,    70,   143,    24,     0,     0,
     186,   270,   270,   270,     0,   198,   270,     0,     0,   210,
     268,   229,   230,     0,     0,     0,     0,   112,   110,   271,
     268,   270,    71,   135,   100,   182,     0,     0,     0,   194,
       0,   270,   217,   227,   231,   270,   225,   108,   247,   270,
      35,     0,   119,     0,   270,    48,   187,   191,   203,   199,
       0,     0,     0,   135,   269,    57,   117,     0,   138,   218,
     232,   111,    36,     0,   126,   271,    49,   138,   180,   162,
     180,   180,   180,   180,   192,   192,   192,   172,     0,   208,
     270,   146,   147,   176,   269,    58,   271,   112,     0,    37,
     161,   163,   164,   165,   166,   167,   168,   169,     0,   171,
     170,     0,   175,     0,   123,   127,    72,   270,     0,   173,
     102,   129,   130,   131,   270,    59,   135,     0,   270,     0,
     106,    73,    50,     0,   128,    60,   138,    38,   109,    74,
      61,     0,   112,   270,    62,     0,   135,    75,    63,   138,
      64,     0,   270,     0,    65
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -391,  -391,  -391,  -391,   219,  -391,  -391,  -391,  -391,  -391,
    -391,  -391,  -391,   133,  -391,  -391,  -391,  -391,  -391,  -391,
    -391,  -391,   136,  -391,  -391,  -391,  -391,  -391,  -391,  -391,
    -391,  -391,  -391,  -391,   115,  -391,  -391,  -391,  -391,  -391,
    -391,  -391,  -391,  -391,    -1,  -391,  -391,  -391,  -391,  -391,
    -391,  -391,  -391,  -391,  -391,  -391,  -391,   -99,  -391,  -391,
    -391,  -391,  -391,  -391,  -391,   233,  -391,  -391,  -391,  -391,
    -391,   165,  -391,  -391,  -391,   149,  -391,  -391,  -391,  -391,
    -391,  -391,  -391,  -391,  -391,  -391,  -391,  -264,  -391,  -268,
    -391,  -179,  -391,  -391,  -391,  -391,  -391,  -391,  -239,  -391,
    -391,  -391,  -391,  -391,  -391,  -192,   -38,  -178,  -391,  -391,
    -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,  -216,
    -391,  -130,    26,  -391,  -391,   -88,  -156,  -391,  -391,  -203,
      32,  -391,  -391,   -92,  -154,  -391,  -391,  -391,  -202,  -391,
    -234,  -391,  -391,  -391,   -53,  -126,  -391,  -391,  -391,   218,
    -391,  -391,  -106,  -391,  -127,   212,  -173,     3,   -43,  -391,
    -391,   255,  -391,  -391,  -391,  -391,  -391,  -391,  -391,  -391,
    -390,  -312,   -13,     0,     4
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     5,     6,     7,     8,    13,    33,    50,    71,
      82,    94,    95,    96,    97,   122,   166,   187,   221,   281,
     114,   115,   116,   117,   146,   217,   271,   343,   417,   453,
     467,   508,   126,   127,   128,   129,   154,   219,   315,   423,
     458,   488,   248,   249,   250,   251,   345,   464,   504,   520,
     528,   532,   536,   539,   541,   348,   349,   350,   351,   444,
     516,   526,   531,    18,    19,    20,    21,    30,    58,    87,
      88,    89,    90,   104,   105,   106,   107,   135,   181,   199,
     255,   319,   184,   455,   121,    24,    41,   310,   311,   386,
     387,   159,   160,   276,   277,   390,   194,   195,   244,   245,
     485,   486,   514,   169,   170,   178,   179,    76,    77,   253,
     254,   213,   480,   214,   235,   481,   498,   215,   482,   241,
     267,   225,   258,   356,   357,   358,   323,   360,   361,   231,
     260,   366,   367,   368,   328,   363,   364,   303,   238,   264,
     237,   287,   331,   332,   333,   288,    53,    59,    60,    61,
     304,   380,   410,   411,   412,    54,   216,   305,    32,    35,
      36,    37,   142,   384,   439,   307,   308,   177,   324,   325,
     326,    67,     9,   226,    16
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       2,   261,   190,    49,    22,   233,   234,   223,    11,   197,
      28,     3,    57,    14,     4,   320,   321,   431,    15,   372,
     327,    70,   320,   321,   377,    26,   381,    46,    29,   378,
      34,    38,    39,   339,   391,   340,    38,   447,    85,   511,
     512,    12,    48,    64,    17,    47,    51,    52,   513,    55,
     174,   175,   176,    23,    62,   335,   292,    27,    66,    31,
      62,    65,    81,  -270,    40,    42,    44,    45,    56,    73,
      74,    63,    78,   227,   228,   229,   230,   283,    72,    86,
     102,    83,    75,   103,   322,    91,    92,  -270,    69,    80,
     112,   322,    84,    93,    99,   143,   100,   111,   433,   101,
     124,   109,   113,   120,   123,   110,   125,   132,   442,   136,
     138,   119,   137,   141,   144,   147,   158,   155,   152,   168,
     162,   131,   134,   183,   189,   133,   156,   173,   157,   224,
     172,   193,   243,   140,   246,   145,   196,   222,   148,   247,
    -270,   236,   149,   252,   256,   165,   153,   150,   151,   257,
     259,   275,   263,   265,   163,   180,   161,   164,   266,   286,
     309,   313,   337,   312,   167,   318,   171,   327,   346,   393,
     191,   347,   354,   355,   182,  -270,   185,   186,  -270,   375,
     218,   371,   370,   188,   379,   382,   374,   383,   192,   198,
     389,   385,   396,   397,   402,   403,   377,   401,   406,   220,
     422,   409,   419,   421,   435,   424,   437,   232,   232,   232,
     438,   425,   239,   240,   448,   429,   242,   436,   456,   454,
     460,   459,   461,   465,   484,    10,   507,   306,   108,   510,
     270,   445,   522,   518,   274,   524,   262,   317,   440,   280,
     527,   533,   139,   537,   499,   542,   273,   544,   278,   272,
     394,   130,    25,    98,   118,   279,   525,   284,   282,   285,
     530,   462,   314,   289,   509,   515,   290,   502,   268,   400,
     446,   495,   496,   497,   269,   405,   449,   500,    68,   373,
     466,   316,   432,   420,   434,    79,   329,   330,   334,   489,
     483,    43,   336,     0,     0,     0,   342,     0,     0,     0,
       0,   338,     0,     0,     0,     0,     0,   341,   506,     0,
       0,     0,     0,     0,     0,   344,     0,   352,   353,     0,
       0,     0,     0,   359,   521,     0,   362,   365,   369,     0,
       0,     0,   334,     0,   392,     0,   376,     0,   490,     0,
     491,   492,   493,   494,   538,   388,     0,     0,   529,     0,
       0,     0,     0,   534,   398,   395,   399,   359,     0,     0,
       0,   540,     0,     0,     0,     0,   404,   369,     0,     0,
     407,     0,   416,     0,   408,     0,     0,     0,     0,   413,
     414,     0,     0,     0,   415,     0,     0,     0,     0,   413,
       0,   418,   291,   292,   293,    31,   294,   295,   296,     0,
       0,   426,   427,   428,     0,     0,   430,     0,     0,     0,
       0,   413,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   443,     0,   441,     0,     0,     0,     0,     0,     0,
       0,   450,     0,     0,     0,   451,     0,     0,     0,   452,
       0,   463,     0,     0,   457,     0,     0,     0,     0,     0,
       0,     0,     0,   200,   297,   298,   299,   300,     0,     0,
       0,   301,     0,     0,     0,   302,     0,     0,     0,   487,
       0,   503,     0,     0,   232,   232,   232,     0,     0,   239,
     501,   200,     0,   242,     0,     0,     0,     0,     0,     0,
     505,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,     0,     0,     0,     0,     0,   517,     0,     0,
       0,     0,     0,   212,   519,     0,     0,     0,   523,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
       0,     0,     0,   535,     0,     0,     0,     0,     0,     0,
       0,   479,   543
};

static const yytype_int16 yycheck[] =
{
       0,   235,   181,    46,    17,   208,   209,   199,     8,   187,
      23,     0,    50,    13,    13,    10,    11,   407,    72,   331,
       8,    64,    10,    11,     7,    21,   338,    40,    24,    12,
      30,    31,    32,     8,   346,    10,    36,   427,    81,    58,
      59,     6,    42,    56,    14,    41,     6,     7,    67,    49,
      55,    56,    57,    19,    54,     6,     7,     6,    58,     9,
      60,    57,    75,     9,    20,    75,     9,    74,    21,    69,
      70,    74,    72,   203,   204,   205,   206,   255,    76,    15,
      93,    77,    22,    16,    79,    85,    86,    78,    78,    74,
     103,    79,    74,    23,    90,   133,    74,     7,   410,    72,
     113,    97,    24,    18,     7,   101,    61,   120,   420,     6,
      73,   107,   125,     9,    72,     6,    28,    74,    72,    60,
      72,   117,   122,    25,     7,   121,    74,    74,    73,     5,
      72,    62,    30,   129,     6,   135,    74,    74,   138,    63,
      75,    75,   142,    43,     6,   158,   146,   143,   144,    75,
      75,    64,    75,    74,   154,   168,   152,   157,    75,     7,
      26,     7,     5,    74,   160,    73,   162,     8,    75,   348,
     183,    65,    73,    10,   170,     4,   172,   177,    77,     5,
     193,    76,    75,   179,     7,    74,    78,     9,   184,   189,
       7,    27,    74,    74,     4,     4,     7,    77,    77,   195,
       7,    76,    72,    76,    78,    74,    74,   207,   208,   209,
       9,    76,   212,   213,     8,    76,   216,    76,    74,    25,
       7,    76,    74,    72,    29,     6,    73,   270,    95,    74,
     243,   423,    74,    73,   247,    74,   236,   280,   417,   252,
      74,    73,   127,    74,   478,    73,   246,    74,   249,   245,
     349,   115,    19,    88,   105,   251,   520,   257,   254,   259,
     528,   453,   275,   263,   498,   504,   266,   483,   242,   357,
     426,   474,   475,   476,   242,   367,   430,   479,    60,   332,
     458,   277,   408,   389,   411,    73,   286,   287,   288,   467,
     463,    36,   289,    -1,    -1,    -1,   309,    -1,    -1,    -1,
      -1,   301,    -1,    -1,    -1,    -1,    -1,   307,   487,    -1,
      -1,    -1,    -1,    -1,    -1,   311,    -1,   317,   318,    -1,
      -1,    -1,    -1,   323,   516,    -1,   326,   327,   328,    -1,
      -1,    -1,   332,    -1,   347,    -1,   336,    -1,   468,    -1,
     470,   471,   472,   473,   536,   345,    -1,    -1,   526,    -1,
      -1,    -1,    -1,   532,   354,   351,   356,   357,    -1,    -1,
      -1,   539,    -1,    -1,    -1,    -1,   366,   367,    -1,    -1,
     370,    -1,   385,    -1,   374,    -1,    -1,    -1,    -1,   379,
     380,    -1,    -1,    -1,   384,    -1,    -1,    -1,    -1,   389,
      -1,   387,     6,     7,     8,     9,    10,    11,    12,    -1,
      -1,   401,   402,   403,    -1,    -1,   406,    -1,    -1,    -1,
      -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   421,    -1,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   431,    -1,    -1,    -1,   435,    -1,    -1,    -1,   439,
      -1,   454,    -1,    -1,   444,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     6,    68,    69,    70,    71,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    79,    -1,    -1,    -1,   465,
      -1,   484,    -1,    -1,   474,   475,   476,    -1,    -1,   479,
     480,     6,    -1,   483,    -1,    -1,    -1,    -1,    -1,    -1,
     486,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    -1,   507,    -1,    -1,
      -1,    -1,    -1,    66,   514,    -1,    -1,    -1,   518,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      -1,    -1,    -1,   533,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,   542
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    81,   253,     0,    13,    82,    83,    84,    85,   252,
      84,   253,     6,    86,   253,    72,   254,    14,   143,   144,
     145,   146,   252,    19,   165,   145,   254,     6,   252,   254,
     147,     9,   238,    87,   253,   239,   240,   241,   253,   253,
      20,   166,    75,   241,     9,    74,   252,   254,   253,   238,
      88,     6,     7,   226,   235,   253,    21,   186,   148,   227,
     228,   229,   253,    74,   252,   254,   253,   251,   229,    78,
     238,    89,    76,   253,   253,    22,   187,   188,   253,   235,
      74,   252,    90,   254,    74,   238,    15,   149,   150,   151,
     152,   253,   253,    23,    91,    92,    93,    94,   151,   254,
      74,    72,   252,    16,   153,   154,   155,   156,    93,   254,
     254,     7,   252,    24,   100,   101,   102,   103,   155,   254,
      18,   164,    95,     7,   252,    61,   112,   113,   114,   115,
     102,   254,   252,   254,   253,   157,     6,   252,    73,   114,
     254,     9,   242,   186,    72,   253,   104,     6,   253,   253,
     254,   254,    72,   253,   116,    74,    74,    73,    28,   171,
     172,   254,    72,   253,   253,   252,    96,   254,    60,   183,
     184,   254,    72,    74,    55,    56,    57,   247,   185,   186,
     252,   158,   254,    25,   162,   254,   253,    97,   254,     7,
     171,   252,   254,    62,   176,   177,    74,   187,   253,   159,
       6,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    66,   191,   193,   197,   236,   105,   252,   117,
     254,    98,    74,   185,     5,   201,   253,   201,   201,   201,
     201,   209,   253,   209,   209,   194,    75,   220,   218,   253,
     253,   199,   253,    30,   178,   179,     6,    63,   122,   123,
     124,   125,    43,   189,   190,   160,     6,    75,   202,    75,
     210,   220,   253,    75,   219,    74,    75,   200,   202,   210,
     252,   106,   254,   253,   252,    64,   173,   174,   124,   254,
     252,    99,   254,   187,   253,   253,     7,   221,   225,   253,
     253,     6,     7,     8,    10,    11,    12,    68,    69,    70,
      71,    75,    79,   217,   230,   237,   238,   245,   246,    26,
     167,   168,    74,     7,   252,   118,   254,   238,    73,   161,
      10,    11,    79,   206,   248,   249,   250,     8,   214,   253,
     253,   222,   223,   224,   253,     6,   237,     5,   253,     8,
      10,   253,   252,   107,   254,   126,    75,    65,   135,   136,
     137,   138,   253,   253,    73,    10,   203,   204,   205,   253,
     207,   208,   253,   215,   216,   253,   211,   212,   213,   253,
      75,    76,   251,   224,    78,     5,   253,     7,    12,     7,
     231,   251,    74,     9,   243,    27,   169,   170,   253,     7,
     175,   251,   252,   171,   137,   254,    74,    74,   253,   253,
     205,    77,     4,     4,   253,   213,    77,   253,   253,    76,
     232,   233,   234,   253,   253,   253,   252,   108,   254,    72,
     232,    76,     7,   119,    74,    76,   253,   253,   253,    76,
     253,   250,   225,   251,   234,    78,    76,    74,     9,   244,
     171,   254,   251,   253,   139,   185,   206,   250,     8,   214,
     253,   253,   253,   109,    25,   163,    74,   253,   120,    76,
       7,    74,   185,   252,   127,    72,   187,   110,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    66,
     192,   195,   198,   236,    29,   180,   181,   254,   121,   187,
     201,   201,   201,   201,   201,   209,   209,   209,   196,   220,
     218,   253,   199,   252,   128,   254,   171,    73,   111,   220,
      74,    58,    59,    67,   182,   178,   140,   253,    73,   253,
     129,   185,    74,   253,    74,   167,   141,    74,   130,   187,
     169,   142,   131,    73,   171,   253,   132,    74,   185,   133,
     187,   134,    73,   253,    74
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    80,    81,    82,    82,    83,    83,    84,    86,    87,
      88,    89,    90,    85,    91,    91,    92,    92,    93,    95,
      96,    97,    98,    99,    94,   100,   100,   101,   101,   102,
     104,   105,   106,   107,   108,   109,   110,   111,   103,   112,
     112,   113,   113,   114,   116,   117,   118,   119,   120,   121,
     115,   122,   122,   123,   123,   124,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   125,   135,   135,   136,   136,
     137,   139,   140,   141,   142,   138,   143,   143,   144,   144,
     145,   147,   148,   146,   149,   149,   150,   150,   151,   152,
     153,   153,   154,   154,   155,   157,   158,   159,   160,   161,
     156,   162,   163,   164,   165,   166,   167,   167,   168,   169,
     169,   170,   171,   171,   172,   173,   173,   174,   175,   175,
     176,   176,   177,   178,   178,   179,   180,   180,   181,   182,
     182,   182,   183,   183,   184,   185,   185,   186,   187,   187,
     188,   189,   189,   190,   191,   191,   192,   192,   193,   193,
     193,   193,   193,   193,   193,   193,   193,   193,   193,   194,
     193,   195,   195,   195,   195,   195,   195,   195,   195,   195,
     195,   195,   196,   195,   197,   198,   199,   199,   200,   200,
     201,   201,   202,   203,   203,   204,   204,   205,   206,   207,
     207,   208,   209,   209,   210,   211,   211,   212,   212,   213,
     214,   215,   215,   216,   217,   217,   217,   217,   218,   218,
     219,   220,   221,   222,   222,   223,   223,   224,   225,   226,
     227,   227,   228,   228,   229,   230,   231,   231,   232,   232,
     233,   233,   234,   235,   235,   236,   236,   237,   237,   238,
     239,   239,   240,   240,   241,   242,   243,   244,   245,   245,
     245,   245,   245,   245,   245,   245,   245,   245,   246,   246,
     247,   247,   247,   248,   248,   249,   250,   250,   251,   252,
     253,   254
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     1,     1,     2,     2,     0,     0,
       0,     0,     0,    27,     0,     1,     1,     2,     2,     0,
       0,     0,     0,     0,    18,     0,     1,     1,     2,     2,
       0,     0,     0,     0,     0,     0,     0,     0,    25,     0,
       1,     1,     2,     2,     0,     0,     0,     0,     0,     0,
      22,     0,     1,     1,     2,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,     1,     1,     2,
       2,     0,     0,     0,     0,    16,     0,     1,     1,     2,
       2,     0,     0,    13,     0,     1,     1,     2,     2,    11,
       0,     1,     1,     2,     2,     0,     0,     0,     0,     0,
      18,     5,     5,     5,     5,     5,     0,     2,     5,     0,
       2,     5,     0,     2,     5,     0,     2,     7,     1,     3,
       0,     2,     5,     0,     2,     5,     0,     2,     5,     1,
       1,     1,     0,     2,     5,     0,     2,     5,     0,     2,
       5,     0,     2,     5,     1,     1,     1,     1,     2,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     0,
       3,     2,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     0,     3,     2,     2,     0,     2,     1,     1,
       0,     2,     6,     0,     1,     1,     2,     4,     2,     0,
       1,     4,     0,     2,     6,     0,     1,     1,     2,     4,
       2,     0,     1,     4,     1,     1,     1,     1,     0,     2,
       5,     5,     3,     0,     1,     1,     2,     4,     7,     3,
       0,     1,     1,     2,     4,     5,     1,     3,     0,     1,
       1,     2,     4,     1,     1,     3,     1,     3,     1,     2,
       0,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     0,     0,
       0,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parserPtr, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, parserPtr); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (parserPtr);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, struct Parser *parserPtr)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, parserPtr);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, struct Parser *parserPtr)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], parserPtr);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parserPtr); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, struct Parser *parserPtr)
{
  YY_USE (yyvaluep);
  YY_USE (parserPtr);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct Parser *parserPtr)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, parserPtr);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* smingFile: optsep moduleStatement_optsep_0n  */
#line 608 "parser-sming.y"
                        {
			    /*
			     * Return the number of successfully
			     * parsed modules.
			     */
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2101 "parser-sming.c"
    break;

  case 3: /* moduleStatement_optsep_0n: %empty  */
#line 618 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 2109 "parser-sming.c"
    break;

  case 4: /* moduleStatement_optsep_0n: moduleStatement_optsep_1n  */
#line 622 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2117 "parser-sming.c"
    break;

  case 5: /* moduleStatement_optsep_1n: moduleStatement_optsep  */
#line 628 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2125 "parser-sming.c"
    break;

  case 6: /* moduleStatement_optsep_1n: moduleStatement_optsep_1n moduleStatement_optsep  */
#line 632 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * modules or return -1, if at least one
			     * module failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2142 "parser-sming.c"
    break;

  case 7: /* moduleStatement_optsep: moduleStatement optsep  */
#line 647 "parser-sming.y"
                        {
			    /*
			     * If we got a (Module *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].modulePtr) != NULL) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2158 "parser-sming.c"
    break;

  case 8: /* $@1: %empty  */
#line 661 "parser-sming.y"
                        {
			    thisParserPtr->modulePtr = findModuleByName((yyvsp[0].text));
			    if (!thisParserPtr->modulePtr) {
				thisParserPtr->modulePtr =
				    addModule((yyvsp[0].text),
					      smiStrdup(thisParserPtr->path),
					      0,
					      thisParserPtr);
			    } else {
			        smiPrintError(thisParserPtr,
					      ERR_MODULE_ALREADY_LOADED,
					      (yyvsp[0].text));
				free((yyvsp[0].text));
				/*
				 * this aborts parsing the whole file,
				 * not only the current module.
				 */
				YYABORT;
			    }
			    thisModulePtr->export.language = SMI_LANGUAGE_SMING;
			    thisParserPtr->modulePtr->numImportedIdentifiers
				                                           = 0;
			    thisParserPtr->modulePtr->numStatements = 0;
			    thisParserPtr->modulePtr->numModuleIdentities = 0;
			    thisParserPtr->firstIndexlabelPtr = NULL;
			    thisParserPtr->identityObjectName = NULL;
			}
#line 2190 "parser-sming.c"
    break;

  case 9: /* $@2: %empty  */
#line 691 "parser-sming.y"
                        {
			    if ((yyvsp[-1].text)) {
				setModuleOrganization(thisParserPtr->modulePtr,
						      (yyvsp[-1].text));
			    }
			}
#line 2201 "parser-sming.c"
    break;

  case 10: /* $@3: %empty  */
#line 698 "parser-sming.y"
                        {
			    if ((yyvsp[-1].text)) {
				setModuleContactInfo(thisParserPtr->modulePtr,
						     (yyvsp[-1].text));
			    }
			}
#line 2212 "parser-sming.c"
    break;

  case 11: /* $@4: %empty  */
#line 705 "parser-sming.y"
                        {
			    if ((yyvsp[-1].text)) {
				setModuleDescription(thisParserPtr->modulePtr,
						     (yyvsp[-1].text), thisParserPtr);
			    }
			}
#line 2223 "parser-sming.c"
    break;

  case 12: /* $@5: %empty  */
#line 712 "parser-sming.y"
                        {
			    if ((yyvsp[0].text)) {
				setModuleReference(thisParserPtr->modulePtr,
						   (yyvsp[0].text), thisParserPtr);
			    }
			}
#line 2234 "parser-sming.c"
    break;

  case 13: /* moduleStatement: moduleKeyword sep ucIdentifier $@1 optsep '{' stmtsep importStatement_stmtsep_0n organizationStatement stmtsep $@2 contactStatement stmtsep $@3 descriptionStatement stmtsep $@4 referenceStatement_stmtsep_01 $@5 revisionStatement_stmtsep_0n extensionStatement_stmtsep_0n identityStatement_stmtsep_0n typedefStatement_stmtsep_0n classStatement_stmtsep_0n '}' optsep ';'  */
#line 724 "parser-sming.y"
                        {
			    checkTypes(thisParserPtr, thisModulePtr);
			    
			    (yyval.modulePtr) = thisModulePtr;
			}
#line 2244 "parser-sming.c"
    break;

  case 14: /* extensionStatement_stmtsep_0n: %empty  */
#line 732 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 2252 "parser-sming.c"
    break;

  case 15: /* extensionStatement_stmtsep_0n: extensionStatement_stmtsep_1n  */
#line 736 "parser-sming.y"
                        {
			    /*
			     * Return the number of successfully
			     * parsed extension statements.
			     */
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2264 "parser-sming.c"
    break;

  case 16: /* extensionStatement_stmtsep_1n: extensionStatement_stmtsep  */
#line 746 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2272 "parser-sming.c"
    break;

  case 17: /* extensionStatement_stmtsep_1n: extensionStatement_stmtsep_1n extensionStatement_stmtsep  */
#line 751 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * extensions or return -1, if at least one
			     * failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2289 "parser-sming.c"
    break;

  case 18: /* extensionStatement_stmtsep: extensionStatement stmtsep  */
#line 766 "parser-sming.y"
                        {
			    /*
			     * If we got a (Type *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].macroPtr)) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2305 "parser-sming.c"
    break;

  case 19: /* $@6: %empty  */
#line 780 "parser-sming.y"
                        {
			    macroIdentifier = (yyvsp[0].text);
			    macroPtr = addMacro(macroIdentifier,
						0,
						thisParserPtr);
			    setMacroDecl(macroPtr, SMI_DECL_EXTENSION);
			}
#line 2317 "parser-sming.c"
    break;

  case 20: /* $@7: %empty  */
#line 789 "parser-sming.y"
                        {
			    if (macroPtr && (yyvsp[0].status)) {
				setMacroStatus(macroPtr, (yyvsp[0].status));
			    }
			}
#line 2327 "parser-sming.c"
    break;

  case 21: /* $@8: %empty  */
#line 795 "parser-sming.y"
                        {
			    if (macroPtr && (yyvsp[0].text)) {
				setMacroDescription(macroPtr, (yyvsp[0].text),
						    thisParserPtr);
			    }
			}
#line 2338 "parser-sming.c"
    break;

  case 22: /* $@9: %empty  */
#line 802 "parser-sming.y"
                        {
			    if (macroPtr && (yyvsp[0].text)) {
				setMacroReference(macroPtr, (yyvsp[0].text),
						  thisParserPtr);
			    }
			}
#line 2349 "parser-sming.c"
    break;

  case 23: /* $@10: %empty  */
#line 809 "parser-sming.y"
                        {
			   if (macroPtr && (yyvsp[0].text)) {
				setMacroAbnf(macroPtr, (yyvsp[0].text),
						  thisParserPtr);
			   }
			}
#line 2360 "parser-sming.c"
    break;

  case 24: /* extensionStatement: extensionKeyword sep lcIdentifier $@6 optsep '{' stmtsep statusStatement_stmtsep_01 $@7 descriptionStatement_stmtsep_01 $@8 referenceStatement_stmtsep_01 $@9 abnfStatement_stmtsep_01 $@10 '}' optsep ';'  */
#line 816 "parser-sming.y"
                        {
			    (yyval.macroPtr) = 0;
			    macroPtr = NULL;
			}
#line 2369 "parser-sming.c"
    break;

  case 25: /* typedefStatement_stmtsep_0n: %empty  */
#line 823 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 2377 "parser-sming.c"
    break;

  case 26: /* typedefStatement_stmtsep_0n: typedefStatement_stmtsep_1n  */
#line 827 "parser-sming.y"
                        {
			    /*
			     * Return the number of successfully
			     * parsed typedef statements.
			     */
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2389 "parser-sming.c"
    break;

  case 27: /* typedefStatement_stmtsep_1n: typedefStatement_stmtsep  */
#line 837 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2397 "parser-sming.c"
    break;

  case 28: /* typedefStatement_stmtsep_1n: typedefStatement_stmtsep_1n typedefStatement_stmtsep  */
#line 842 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * typedefs or return -1, if at least one
			     * failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2414 "parser-sming.c"
    break;

  case 29: /* typedefStatement_stmtsep: typedefStatement stmtsep  */
#line 857 "parser-sming.y"
                        {
			    /*
			     * If we got a (Type *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].typePtr)) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2430 "parser-sming.c"
    break;

  case 30: /* $@11: %empty  */
#line 871 "parser-sming.y"
                        {
			    typeIdentifier = (yyvsp[0].text);
			    /* 
			     *check for duplicate names in the module 
			     */
			    if(typePtr = 
			    	findType(typeIdentifier, thisParserPtr,thisModulePtr)) 
					if( typePtr->modulePtr == thisParserPtr->modulePtr)
					       smiPrintError(thisParserPtr,
										ERR_DUPLICATE_TYPE_NAME,
					      				typeIdentifier);
			}
#line 2447 "parser-sming.c"
    break;

  case 31: /* $@12: %empty  */
#line 885 "parser-sming.y"
                        {
			    if ((yyvsp[-1].typePtr)) {
				if ((yyvsp[-1].typePtr)->export.name) {
				    /*
				     * If the exact type has been found
				     * and no new Type structure has been
				     * created, we have to create a
				     * duplicate now.
				     */
				    typePtr = duplicateType((yyvsp[-1].typePtr), 0,
							    thisParserPtr);
				} else {
				    typePtr = (yyvsp[-1].typePtr);
				}
				typePtr = setTypeName(typePtr, typeIdentifier);
				setTypeDecl(typePtr, SMI_DECL_TYPEDEF);
			    }
			    defaultBasetype = typePtr->export.basetype;
			}
#line 2471 "parser-sming.c"
    break;

  case 32: /* $@13: %empty  */
#line 905 "parser-sming.y"
                        {
			    if (typePtr && (yyvsp[0].valuePtr)) {
			    	if(typePtr->export.basetype == 
			    					SMI_BASETYPE_ENUM) 
			    					//check ENUM value for correctness
    				{
    					if((yyvsp[0].valuePtr)->len)
    	 				if(namedNumberPtr = findNamedNumberByName(typePtr,
    	 												 (yyvsp[0].valuePtr)->value.ptr)){
    	 					smiFree((yyvsp[0].valuePtr));
    	 					(yyvsp[0].valuePtr) = &namedNumberPtr->export.value;
    	 				}
    	 				else{ smiPrintError(thisParserPtr,
					      		ERR_ENUM_NAME_NOT_DEFINED,
					      		(yyvsp[0].valuePtr)->value.ptr);
					    }
    	 			}
    	 			//NOTE that the bits default value is set in the anyval
    	 			//rule
				setTypeValue(typePtr, (yyvsp[0].valuePtr));
			    }
			}
#line 2498 "parser-sming.c"
    break;

  case 33: /* $@14: %empty  */
#line 928 "parser-sming.y"
                        {
			    if (typePtr && (yyvsp[0].text)
				&& smiCheckFormat(thisParserPtr,
						  typePtr->export.basetype,
						  (yyvsp[0].text), 0)) {
				setTypeFormat(typePtr, (yyvsp[0].text));
			    }
			}
#line 2511 "parser-sming.c"
    break;

  case 34: /* $@15: %empty  */
#line 937 "parser-sming.y"
                        {
			    if (typePtr && (yyvsp[0].text)) {
				setTypeUnits(typePtr, (yyvsp[0].text));
			    }
			}
#line 2521 "parser-sming.c"
    break;

  case 35: /* $@16: %empty  */
#line 943 "parser-sming.y"
                        {
			    if (typePtr && (yyvsp[0].status)) {
				setTypeStatus(typePtr, (yyvsp[0].status));
			    }
			}
#line 2531 "parser-sming.c"
    break;

  case 36: /* $@17: %empty  */
#line 949 "parser-sming.y"
                        {
			    if (typePtr && (yyvsp[0].text)) {
				setTypeDescription(typePtr, (yyvsp[0].text),
						   thisParserPtr);
			    }
			}
#line 2542 "parser-sming.c"
    break;

  case 37: /* $@18: %empty  */
#line 956 "parser-sming.y"
                        {
			    if (typePtr && (yyvsp[0].text)) {
				setTypeReference(typePtr, (yyvsp[0].text), thisParserPtr);
			    }
			}
#line 2552 "parser-sming.c"
    break;

  case 38: /* typedefStatement: typedefKeyword sep ucIdentifier $@11 optsep '{' stmtsep typedefTypeStatement stmtsep $@12 defaultStatement_stmtsep_01 $@13 formatStatement_stmtsep_01 $@14 unitsStatement_stmtsep_01 $@15 statusStatement_stmtsep_01 $@16 descriptionStatement_stmtsep_01 $@17 referenceStatement_stmtsep_01 $@18 '}' optsep ';'  */
#line 962 "parser-sming.y"
                        {
			    smiCheckNamedNumberSubtyping(thisParserPtr , typePtr);
			    smiCheckNamedNumbersOrder(thisParserPtr , typePtr);
			    smiCheckNamedNumberRedefinition(thisParserPtr , typePtr);
			    (yyval.typePtr) = 0;
			    typePtr = NULL;
			    free(typeIdentifier);
			    defaultBasetype = SMI_BASETYPE_UNKNOWN;
			}
#line 2566 "parser-sming.c"
    break;

  case 39: /* classStatement_stmtsep_0n: %empty  */
#line 974 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 2574 "parser-sming.c"
    break;

  case 40: /* classStatement_stmtsep_0n: classStatement_stmtsep_1n  */
#line 978 "parser-sming.y"
                        {
			    /*
			     * Return the number of successfully
			     * parsed typedef statements.
			     */
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2586 "parser-sming.c"
    break;

  case 41: /* classStatement_stmtsep_1n: classStatement_stmtsep  */
#line 988 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2594 "parser-sming.c"
    break;

  case 42: /* classStatement_stmtsep_1n: classStatement_stmtsep_1n classStatement_stmtsep  */
#line 993 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * classes or return -1, if at least one
			     * failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2611 "parser-sming.c"
    break;

  case 43: /* classStatement_stmtsep: classStatement stmtsep  */
#line 1008 "parser-sming.y"
                        {
			    /*
			     * If we got a (Type *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].classPtr)) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2627 "parser-sming.c"
    break;

  case 44: /* $@19: %empty  */
#line 1022 "parser-sming.y"
                        {
			    classIdentifier = (yyvsp[0].text);
			    if(findClassByModuleAndName(thisModulePtr, classIdentifier))
			    {
			    	smiPrintError(thisParserPtr,
										ERR_DUPLICATE_CLASS_NAME,
					      				attributeIdentifier);
			    }
			    else{
			    classPtr = addClass(classIdentifier,
						thisParserPtr);
			    setClassDecl(classPtr, SMI_DECL_CLASS);
			    }
			}
#line 2646 "parser-sming.c"
    break;

  case 45: /* $@20: %empty  */
#line 1038 "parser-sming.y"
                        {
				if(classPtr && (yyvsp[0].classPtr))
					classPtr->parentPtr = (yyvsp[0].classPtr);
			}
#line 2655 "parser-sming.c"
    break;

  case 46: /* $@21: %empty  */
#line 1044 "parser-sming.y"
                        {
				List *tmpList;
				Attribute *tmpAttribute;
				if(classPtr && (yyvsp[0].listPtr))
				{
					
					//Check for "magic" value #@# that defines
					//scalar class. See NOTE after Class definitino in data.h
					if(!strcmp((char*)((yyvsp[0].listPtr)->ptr),"#@#"))
					{	
						classPtr->uniqueList = (List*)malloc(sizeof(List));
						classPtr->uniqueList->ptr = classPtr;
						classPtr->uniqueList->nextPtr = NULL;
						smiFree((yyvsp[0].listPtr));
					}
					else
					{
						tmpList = (yyvsp[0].listPtr);
						//convert  all attribute names to atributes
						for(tmpList; tmpList; tmpList=tmpList->nextPtr)
						{
							if(tmpAttribute = 
							(Attribute*)smiGetAttribute(&(classPtr->export),(char*)(tmpList->ptr)))
							{
								smiFree(tmpList->ptr);
								tmpList->ptr = tmpAttribute;
							}
							else
							{
								smiFree(tmpList->ptr);
								tmpList->ptr = NULL;
								smiPrintError(thisParserPtr,
										ERR_ATTRIBUTE_NOT_FOUND,
					      				attributeIdentifier);
							}
						}
						
						classPtr->uniqueList = (yyvsp[0].listPtr);
					}
				}
			}
#line 2701 "parser-sming.c"
    break;

  case 47: /* $@22: %empty  */
#line 1087 "parser-sming.y"
                        {
			    if (classPtr && (yyvsp[0].status)) {
				setClassStatus(classPtr, (yyvsp[0].status));
			    }
			}
#line 2711 "parser-sming.c"
    break;

  case 48: /* $@23: %empty  */
#line 1093 "parser-sming.y"
                        {
			    if (classPtr && (yyvsp[0].text)) {
				setClassDescription(classPtr, (yyvsp[0].text),
						    thisParserPtr);
			    }
			}
#line 2722 "parser-sming.c"
    break;

  case 49: /* $@24: %empty  */
#line 1100 "parser-sming.y"
                        {
			    if (classPtr && (yyvsp[0].text)) {
				setClassReference(classPtr, (yyvsp[0].text),
						  thisParserPtr);
			    }
			}
#line 2733 "parser-sming.c"
    break;

  case 50: /* classStatement: classKeyword sep ucIdentifier $@19 optsep '{' stmtsep extendsStatement_stmtsep_01 $@20 attributeStatement_stmtsep_0n uniqueStatement_stmtsep_01 $@21 eventStatement_stmtsep_0n statusStatement_stmtsep_01 $@22 descriptionStatement_stmtsep_01 $@23 referenceStatement_stmtsep_01 $@24 '}' optsep ';'  */
#line 1107 "parser-sming.y"
                        {
			    (yyval.classPtr) = 0;
			    classPtr = NULL;
			}
#line 2742 "parser-sming.c"
    break;

  case 51: /* attributeStatement_stmtsep_0n: %empty  */
#line 1114 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 2750 "parser-sming.c"
    break;

  case 52: /* attributeStatement_stmtsep_0n: attributeStatement_stmtsep_1n  */
#line 1118 "parser-sming.y"
                        {
			    /*
			     * Return the number of successfully
			     * parsed typedef statements.
			     */
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2762 "parser-sming.c"
    break;

  case 53: /* attributeStatement_stmtsep_1n: attributeStatement_stmtsep  */
#line 1128 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2770 "parser-sming.c"
    break;

  case 54: /* attributeStatement_stmtsep_1n: attributeStatement_stmtsep_1n attributeStatement_stmtsep  */
#line 1133 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * attributes or return -1, if at least one
			     * failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2787 "parser-sming.c"
    break;

  case 55: /* attributeStatement_stmtsep: attributeStatement stmtsep  */
#line 1148 "parser-sming.y"
                        {
			    /*
			     * If we got a (Type *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].attributePtr)) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2803 "parser-sming.c"
    break;

  case 56: /* $@25: %empty  */
#line 1162 "parser-sming.y"
                                        {
						attributeIdentifier = (yyvsp[0].text);
						attributePtr = (Attribute*)smiGetAttribute(&(classPtr->export),
												attributeIdentifier);
						if(attributePtr)
						{
							smiPrintError(thisParserPtr,
										ERR_DUPLICATE_ATTRIBUTE_NAME,
					      				attributeIdentifier);
					      	attributePtr = NULL;
						}					
					}
#line 2820 "parser-sming.c"
    break;

  case 57: /* $@26: %empty  */
#line 1176 "parser-sming.y"
                                        {
			    		if ((yyvsp[0].attributePtr)) {
				    		attributePtr = (yyvsp[0].attributePtr);
							setAttributeName(attributePtr, 
											attributeIdentifier);
							setAttributeDecl(attributePtr, 
												SMI_DECL_ATTRIBUTE);
							defaultBasetype = attributePtr->export.basetype;
			    		}
					}
#line 2835 "parser-sming.c"
    break;

  case 58: /* $@27: %empty  */
#line 1187 "parser-sming.y"
                                        {
						if((yyvsp[0].access) && attributePtr){
						/* check whether there's access for class reference, 
						   which is not allowed */
							if(attributePtr->parentClassPtr)
								smiPrintError(thisParserPtr,
										ERR_ATTRIBUTE_CLASS_ACCESS,
					      							attributeIdentifier);
					      	else {
					      		setAttributeAccess(attributePtr,(yyvsp[0].access));
					      	}
						}
						else if(attributePtr && attributePtr->parentTypePtr)
						{
							smiPrintError(thisParserPtr,
										ERR_ATTRIBUTE_MISSING_ACCESS,
					      							attributeIdentifier);
						}
					}
#line 2859 "parser-sming.c"
    break;

  case 59: /* $@28: %empty  */
#line 1207 "parser-sming.y"
                                        {
						if((yyvsp[0].valuePtr) && attributePtr){
							if(attributePtr->parentClassPtr)
								smiPrintError(thisParserPtr,
										ERR_ATTRIBUTE_CLASS_DEFAULT,
					      							attributeIdentifier);
					      	else{
					      		attributePtr->export.value = *(yyvsp[0].valuePtr);
					      	}
						}
						else if(attributePtr)
						{
							attributePtr->export.value.basetype = 
													SMI_BASETYPE_UNKNOWN;
						}
					}
#line 2880 "parser-sming.c"
    break;

  case 60: /* $@29: %empty  */
#line 1224 "parser-sming.y"
                                        {
			   			if((yyvsp[0].text) && attributePtr){
							if(attributePtr->parentClassPtr)
								smiPrintError(thisParserPtr,
										ERR_ATTRIBUTE_CLASS_FORMAT,
					      							attributeIdentifier);
					      	else{
					      		if (smiCheckFormat(thisParserPtr,
						  				attributePtr->export.basetype,(yyvsp[0].text), 0)) 
						  		{
									attributePtr->export.format = (yyvsp[0].text);
					      		}
					      	}
						}
			    	}
#line 2900 "parser-sming.c"
    break;

  case 61: /* $@30: %empty  */
#line 1240 "parser-sming.y"
                                        {
			    		if((yyvsp[0].text) && attributePtr){
							if(attributePtr->parentClassPtr)
								smiPrintError(thisParserPtr,
										ERR_ATTRIBUTE_CLASS_UNITS,
					      							attributeIdentifier);
					      	else{
									attributePtr->export.units = (yyvsp[0].text);
					      	}
						}
					}
#line 2916 "parser-sming.c"
    break;

  case 62: /* $@31: %empty  */
#line 1252 "parser-sming.y"
                                        {
			   			if (attributePtr && (yyvsp[0].status)) 
							attributePtr->export.status = (yyvsp[0].status);
					}
#line 2925 "parser-sming.c"
    break;

  case 63: /* $@32: %empty  */
#line 1257 "parser-sming.y"
                                        {
						if (attributePtr && (yyvsp[0].text)) 
							attributePtr->export.description = (yyvsp[0].text);
					}
#line 2934 "parser-sming.c"
    break;

  case 64: /* $@33: %empty  */
#line 1262 "parser-sming.y"
                                        {
						if (attributePtr && (yyvsp[0].text)) 
							attributePtr->export.reference = (yyvsp[0].text);
			    	}
#line 2943 "parser-sming.c"
    break;

  case 65: /* attributeStatement: attributeKeyword sep lcIdentifier $@25 optsep '{' stmtsep attributeTypeStatement $@26 accessStatement_stmtsep_01 $@27 defaultStatement_stmtsep_01 $@28 formatStatement_stmtsep_01 $@29 unitsStatement_stmtsep_01 $@30 statusStatement_stmtsep_01 $@31 descriptionStatement_stmtsep_01 $@32 referenceStatement_stmtsep_01 $@33 '}' optsep ';'  */
#line 1267 "parser-sming.y"
                                        {
						(yyval.attributePtr) = attributePtr;
						attributePtr = NULL;
						defaultBasetype = SMI_BASETYPE_UNKNOWN;
					}
#line 2953 "parser-sming.c"
    break;

  case 66: /* eventStatement_stmtsep_0n: %empty  */
#line 1275 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 2961 "parser-sming.c"
    break;

  case 67: /* eventStatement_stmtsep_0n: eventStatement_stmtsep_1n  */
#line 1279 "parser-sming.y"
                        {
			    /*
			     * Return the number of successfully
			     * parsed event statements.
			     */
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2973 "parser-sming.c"
    break;

  case 68: /* eventStatement_stmtsep_1n: eventStatement_stmtsep  */
#line 1289 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 2981 "parser-sming.c"
    break;

  case 69: /* eventStatement_stmtsep_1n: eventStatement_stmtsep_1n eventStatement_stmtsep  */
#line 1294 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * events or return -1, if at least one
			     * failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 2998 "parser-sming.c"
    break;

  case 70: /* eventStatement_stmtsep: eventStatement stmtsep  */
#line 1309 "parser-sming.y"
                        {
			    /*
			     * If we got a (Type *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].eventPtr)) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 3014 "parser-sming.c"
    break;

  case 71: /* $@34: %empty  */
#line 1323 "parser-sming.y"
                        {
				//TODO check for repeated names
				eventPtr=addEvent((yyvsp[0].text),classPtr,thisParserPtr);
			}
#line 3023 "parser-sming.c"
    break;

  case 72: /* $@35: %empty  */
#line 1329 "parser-sming.y"
                        {
				if((yyvsp[0].status) && eventPtr)
				eventPtr->export.status = (yyvsp[0].status);
			}
#line 3032 "parser-sming.c"
    break;

  case 73: /* $@36: %empty  */
#line 1334 "parser-sming.y"
                        {
				if((yyvsp[0].text) && eventPtr)
				eventPtr->export.description = (yyvsp[0].text);
			}
#line 3041 "parser-sming.c"
    break;

  case 74: /* $@37: %empty  */
#line 1339 "parser-sming.y"
                        {
				if((yyvsp[0].text) && eventPtr)
				eventPtr->export.reference = (yyvsp[0].text);
			}
#line 3050 "parser-sming.c"
    break;

  case 75: /* eventStatement: eventKeyword sep lcIdentifier $@34 optsep '{' stmtsep statusStatement_stmtsep_01 $@35 descriptionStatement_stmtsep_01 $@36 referenceStatement_stmtsep_01 $@37 '}' optsep ';'  */
#line 1344 "parser-sming.y"
                        {
				(yyval.eventPtr) = eventPtr;
				eventPtr = NULL;
			}
#line 3059 "parser-sming.c"
    break;

  case 76: /* importStatement_stmtsep_0n: %empty  */
#line 1351 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 3067 "parser-sming.c"
    break;

  case 77: /* importStatement_stmtsep_0n: importStatement_stmtsep_1n  */
#line 1355 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 3075 "parser-sming.c"
    break;

  case 78: /* importStatement_stmtsep_1n: importStatement_stmtsep  */
#line 1361 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 3083 "parser-sming.c"
    break;

  case 79: /* importStatement_stmtsep_1n: importStatement_stmtsep_1n importStatement_stmtsep  */
#line 1365 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * imports or return -1, if at least one
			     * module failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 3100 "parser-sming.c"
    break;

  case 80: /* importStatement_stmtsep: importStatement stmtsep  */
#line 1380 "parser-sming.y"
                        {
			    /*
			     * If we got an (Object *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].listPtr)) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 3116 "parser-sming.c"
    break;

  case 81: /* $@38: %empty  */
#line 1394 "parser-sming.y"
                        {
			    importModulename = smiStrdup((yyvsp[0].text));
			}
#line 3124 "parser-sming.c"
    break;

  case 82: /* $@39: %empty  */
#line 1399 "parser-sming.y"
                        {
			    List *listPtr, *nextPtr;
			    
			    for (listPtr = (yyvsp[0].listPtr); listPtr; listPtr = nextPtr) {
				addImport(listPtr->ptr, thisParserPtr);
				thisParserPtr->modulePtr->
				                      numImportedIdentifiers++;
				nextPtr = listPtr->nextPtr;
				free(listPtr);
			    }
			}
#line 3140 "parser-sming.c"
    break;

  case 83: /* importStatement: importKeyword sep ucIdentifier $@38 optsep '(' optsep identifierList $@39 optsep ')' optsep ';'  */
#line 1411 "parser-sming.y"
                        {
			    Module *modulePtr;
			    char *s = importModulename;

			    modulePtr = findModuleByName(s);
			    if (!modulePtr) {
				modulePtr = loadModule(s, thisParserPtr);
			    }
			    checkImports(modulePtr, thisParserPtr);
			    free(s);
			    (yyval.listPtr) = NULL;
			}
#line 3157 "parser-sming.c"
    break;

  case 84: /* revisionStatement_stmtsep_0n: %empty  */
#line 1426 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 3165 "parser-sming.c"
    break;

  case 85: /* revisionStatement_stmtsep_0n: revisionStatement_stmtsep_1n  */
#line 1430 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 3173 "parser-sming.c"
    break;

  case 86: /* revisionStatement_stmtsep_1n: revisionStatement_stmtsep  */
#line 1436 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 3181 "parser-sming.c"
    break;

  case 87: /* revisionStatement_stmtsep_1n: revisionStatement_stmtsep_1n revisionStatement_stmtsep  */
#line 1440 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * revisions or return -1, if at least one
			     * module failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 3198 "parser-sming.c"
    break;

  case 88: /* revisionStatement_stmtsep: revisionStatement stmtsep  */
#line 1455 "parser-sming.y"
                           {
			       /*
				* If we got a (Revision *) return rc == 1,
				* otherwise parsing failed (rc == -1).
				*/
			       if ((yyvsp[-1].revisionPtr)) {
				(yyval.rc) = 1;
			       } else {
				   (yyval.rc) = -1;
			       }
			   }
#line 3214 "parser-sming.c"
    break;

  case 89: /* revisionStatement: revisionKeyword optsep '{' stmtsep dateStatement stmtsep descriptionStatement stmtsep '}' optsep ';'  */
#line 1472 "parser-sming.y"
                        {
			    (yyval.revisionPtr) = addRevision((yyvsp[-6].date), (yyvsp[-4].text), thisParserPtr);
			}
#line 3222 "parser-sming.c"
    break;

  case 90: /* identityStatement_stmtsep_0n: %empty  */
#line 1478 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 3230 "parser-sming.c"
    break;

  case 91: /* identityStatement_stmtsep_0n: identityStatement_stmtsep_1n  */
#line 1482 "parser-sming.y"
                        {
			    /*
			     * Return the number of successfully
			     * parsed identity statements.
			     */
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 3242 "parser-sming.c"
    break;

  case 92: /* identityStatement_stmtsep_1n: identityStatement_stmtsep  */
#line 1492 "parser-sming.y"
                        {
			    (yyval.rc) = (yyvsp[0].rc);
			}
#line 3250 "parser-sming.c"
    break;

  case 93: /* identityStatement_stmtsep_1n: identityStatement_stmtsep_1n identityStatement_stmtsep  */
#line 1497 "parser-sming.y"
                        {
			    /*
			     * Sum up the number of successfully parsed
			     * identities or return -1, if at least one
			     * failed.
			     */
			    if (((yyvsp[-1].rc) >= 0) && ((yyvsp[0].rc) >= 0)) {
				(yyval.rc) = (yyvsp[-1].rc) + (yyvsp[0].rc);
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 3267 "parser-sming.c"
    break;

  case 94: /* identityStatement_stmtsep: identityStatement stmtsep  */
#line 1512 "parser-sming.y"
                        {
			    /*
			     * If we got a (Type *) return rc == 1,
			     * otherwise parsing failed (rc == -1).
			     */
			    if ((yyvsp[-1].identityPtr)) {
				(yyval.rc) = 1;
			    } else {
				(yyval.rc) = -1;
			    }
			}
#line 3283 "parser-sming.c"
    break;

  case 95: /* $@40: %empty  */
#line 1526 "parser-sming.y"
                        {
				identityIdentifier = (yyvsp[0].text);
				identityPtr = addIdentity(identityIdentifier,
						thisParserPtr);
			    setIdentityDecl(identityPtr, SMI_DECL_IDENTITY);
			}
#line 3294 "parser-sming.c"
    break;

  case 96: /* $@41: %empty  */
#line 1534 "parser-sming.y"
                        {
				if(identityPtr && (yyvsp[0].identityPtr)) {
					setIdentityParent(identityPtr,(yyvsp[0].identityPtr));
				}
			}
#line 3304 "parser-sming.c"
    break;

  case 97: /* $@42: %empty  */
#line 1540 "parser-sming.y"
                        {
			    if (identityPtr && (yyvsp[0].status)) {
				setIdentityStatus(identityPtr, (yyvsp[0].status));
			    }
			}
#line 3314 "parser-sming.c"
    break;

  case 98: /* $@43: %empty  */
#line 1546 "parser-sming.y"
                        {
				if (identityPtr && (yyvsp[0].text)) {
				setIdentityDescription(identityPtr, (yyvsp[0].text),
						    			thisParserPtr);
			    }
			}
#line 3325 "parser-sming.c"
    break;

  case 99: /* $@44: %empty  */
#line 1553 "parser-sming.y"
                        {
				setIdentityReference(identityPtr, (yyvsp[0].text), 
									 thisParserPtr);
			}
#line 3334 "parser-sming.c"
    break;

  case 100: /* identityStatement: identityKeyword sep lcIdentifier $@40 optsep '{' stmtsep parentStatement_stmtsep_01 $@41 statusStatement_stmtsep_01 $@42 descriptionStatement_stmtsep_01 $@43 referenceStatement_stmtsep_01 $@44 '}' optsep ';'  */
#line 1558 "parser-sming.y"
                        {
			    (yyval.identityPtr) = 0;
			    identityPtr = NULL;
			}
#line 3343 "parser-sming.c"
    break;

  case 101: /* typedefTypeStatement: typeKeyword sep refinedBaseType_refinedType optsep ';'  */
#line 1565 "parser-sming.y"
                        {
			    (yyval.typePtr) = (yyvsp[-2].typePtr);
			}
#line 3351 "parser-sming.c"
    break;

  case 102: /* attributeTypeStatement: typeKeyword sep attribute_refinedBaseType_refinedType optsep ';'  */
#line 1571 "parser-sming.y"
                        {
			    (yyval.attributePtr) = (yyvsp[-2].attributePtr);
			}
#line 3359 "parser-sming.c"
    break;

  case 103: /* dateStatement: dateKeyword sep date optsep ';'  */
#line 1577 "parser-sming.y"
                        {
			    (yyval.date) = (yyvsp[-2].date);
			}
#line 3367 "parser-sming.c"
    break;

  case 104: /* organizationStatement: organizationKeyword sep text optsep ';'  */
#line 1583 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 3375 "parser-sming.c"
    break;

  case 105: /* contactStatement: contactKeyword sep text optsep ';'  */
#line 1589 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 3383 "parser-sming.c"
    break;

  case 106: /* formatStatement_stmtsep_01: %empty  */
#line 1595 "parser-sming.y"
                        {
			    (yyval.text) = NULL;
			}
#line 3391 "parser-sming.c"
    break;

  case 107: /* formatStatement_stmtsep_01: formatStatement stmtsep  */
#line 1599 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-1].text);
			}
#line 3399 "parser-sming.c"
    break;

  case 108: /* formatStatement: formatKeyword sep format optsep ';'  */
#line 1605 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 3407 "parser-sming.c"
    break;

  case 109: /* unitsStatement_stmtsep_01: %empty  */
#line 1611 "parser-sming.y"
                        {
			    (yyval.text) = NULL;
			}
#line 3415 "parser-sming.c"
    break;

  case 110: /* unitsStatement_stmtsep_01: unitsStatement stmtsep  */
#line 1615 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-1].text);
			}
#line 3423 "parser-sming.c"
    break;

  case 111: /* unitsStatement: unitsKeyword sep units optsep ';'  */
#line 1621 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 3431 "parser-sming.c"
    break;

  case 112: /* statusStatement_stmtsep_01: %empty  */
#line 1627 "parser-sming.y"
                        {
			    (yyval.status) = SMI_STATUS_CURRENT;
			}
#line 3439 "parser-sming.c"
    break;

  case 113: /* statusStatement_stmtsep_01: statusStatement stmtsep  */
#line 1631 "parser-sming.y"
                        {
			    (yyval.status) = (yyvsp[-1].status);
			}
#line 3447 "parser-sming.c"
    break;

  case 114: /* statusStatement: statusKeyword sep status optsep ';'  */
#line 1637 "parser-sming.y"
                        {
			    (yyval.status) = (yyvsp[-2].status);
			}
#line 3455 "parser-sming.c"
    break;

  case 115: /* uniqueStatement_stmtsep_01: %empty  */
#line 1643 "parser-sming.y"
                {
			    (yyval.listPtr) = NULL;
			}
#line 3463 "parser-sming.c"
    break;

  case 116: /* uniqueStatement_stmtsep_01: uniqueStatement stmtsep  */
#line 1647 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 3471 "parser-sming.c"
    break;

  case 117: /* uniqueStatement: uniqueKeyword sep '(' uniqueSpec ')' optsep ';'  */
#line 1653 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[-3].listPtr);
			}
#line 3479 "parser-sming.c"
    break;

  case 118: /* uniqueSpec: optsep_comma_01  */
#line 1659 "parser-sming.y"
                        {
				(yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = "#@#"; //used to indicate that unique
			    				 //statement is present and empty
			    				 //i.e. the class is scalar
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 3491 "parser-sming.c"
    break;

  case 119: /* uniqueSpec: lcIdentifier furtherLcIdentifier_0n optsep_comma_01  */
#line 1667 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[-2].text);
			    (yyval.listPtr)->nextPtr = (yyvsp[-1].listPtr);
			}
#line 3501 "parser-sming.c"
    break;

  case 120: /* extendsStatement_stmtsep_01: %empty  */
#line 1678 "parser-sming.y"
                        {
			    (yyval.classPtr) = NULL;
			}
#line 3509 "parser-sming.c"
    break;

  case 121: /* extendsStatement_stmtsep_01: extendsStatement stmtsep  */
#line 1682 "parser-sming.y"
                        {
			    (yyval.classPtr) = (yyvsp[-1].classPtr);
			}
#line 3517 "parser-sming.c"
    break;

  case 122: /* extendsStatement: extendsKeyword sep ucIdentifier optsep ';'  */
#line 1688 "parser-sming.y"
                        {
			    (yyval.classPtr) = findClass((yyvsp[-2].text), thisParserPtr,thisModulePtr);
			    if(!(yyval.classPtr))smiPrintError(thisParserPtr,
					      ERR_UNKNOWN_CLASS,
					      (yyvsp[-2].text));
			    
			}
#line 3529 "parser-sming.c"
    break;

  case 123: /* defaultStatement_stmtsep_01: %empty  */
#line 1698 "parser-sming.y"
                        {
			    (yyval.valuePtr) = NULL;
			}
#line 3537 "parser-sming.c"
    break;

  case 124: /* defaultStatement_stmtsep_01: defaultStatement stmtsep  */
#line 1702 "parser-sming.y"
                        {
			    (yyval.valuePtr) = (yyvsp[-1].valuePtr);
			}
#line 3545 "parser-sming.c"
    break;

  case 125: /* defaultStatement: defaultKeyword sep anyValue optsep ';'  */
#line 1708 "parser-sming.y"
                        {
			    (yyval.valuePtr) = (yyvsp[-2].valuePtr);
			}
#line 3553 "parser-sming.c"
    break;

  case 126: /* accessStatement_stmtsep_01: %empty  */
#line 1714 "parser-sming.y"
                        {
			    (yyval.access) = SMI_ACCESS_UNKNOWN;
			}
#line 3561 "parser-sming.c"
    break;

  case 127: /* accessStatement_stmtsep_01: accessStatement stmtsep  */
#line 1718 "parser-sming.y"
                        {
			    (yyval.access) = (yyvsp[-1].access);
			}
#line 3569 "parser-sming.c"
    break;

  case 128: /* accessStatement: accessKeyword sep access optsep ';'  */
#line 1724 "parser-sming.y"
                        {
			    (yyval.access) = (yyvsp[-2].access);
			}
#line 3577 "parser-sming.c"
    break;

  case 129: /* access: readonlyKeyword  */
#line 1730 "parser-sming.y"
                        {
				(yyval.access) = SMI_ACCESS_READ_ONLY;
			}
#line 3585 "parser-sming.c"
    break;

  case 130: /* access: readwriteKeyword  */
#line 1734 "parser-sming.y"
                        {
				(yyval.access) = SMI_ACCESS_READ_WRITE;
			}
#line 3593 "parser-sming.c"
    break;

  case 131: /* access: eventonlyKeyword  */
#line 1738 "parser-sming.y"
                        {
				(yyval.access) = SMI_ACCESS_EVENT_ONLY;
			}
#line 3601 "parser-sming.c"
    break;

  case 132: /* parentStatement_stmtsep_01: %empty  */
#line 1744 "parser-sming.y"
                        {
			    (yyval.identityPtr) = NULL;
			}
#line 3609 "parser-sming.c"
    break;

  case 133: /* parentStatement_stmtsep_01: parentStatement stmtsep  */
#line 1748 "parser-sming.y"
                        {
			    (yyval.identityPtr) = (yyvsp[-1].identityPtr);
			}
#line 3617 "parser-sming.c"
    break;

  case 134: /* parentStatement: parentKeyword sep lcIdentifier optsep ';'  */
#line 1754 "parser-sming.y"
                        {
			    (yyval.identityPtr) = findIdentity((yyvsp[-2].text), thisParserPtr, thisModulePtr);
			    if(!(yyval.identityPtr))smiPrintError(thisParserPtr,
					      ERR_IDENTITY_PARENT_NOT_FOUND,
					      (yyvsp[-2].text));
			}
#line 3628 "parser-sming.c"
    break;

  case 135: /* descriptionStatement_stmtsep_01: %empty  */
#line 1763 "parser-sming.y"
                        {
			    (yyval.text) = NULL;
			}
#line 3636 "parser-sming.c"
    break;

  case 136: /* descriptionStatement_stmtsep_01: descriptionStatement stmtsep  */
#line 1767 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-1].text);
			}
#line 3644 "parser-sming.c"
    break;

  case 137: /* descriptionStatement: descriptionKeyword sep text optsep ';'  */
#line 1773 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 3652 "parser-sming.c"
    break;

  case 138: /* referenceStatement_stmtsep_01: %empty  */
#line 1779 "parser-sming.y"
                        {
			    (yyval.text) = NULL;
			}
#line 3660 "parser-sming.c"
    break;

  case 139: /* referenceStatement_stmtsep_01: referenceStatement stmtsep  */
#line 1783 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-1].text);
			}
#line 3668 "parser-sming.c"
    break;

  case 140: /* referenceStatement: referenceKeyword sep text optsep ';'  */
#line 1789 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 3676 "parser-sming.c"
    break;

  case 141: /* abnfStatement_stmtsep_01: %empty  */
#line 1795 "parser-sming.y"
                        {
			    (yyval.text) = NULL;
			}
#line 3684 "parser-sming.c"
    break;

  case 142: /* abnfStatement_stmtsep_01: abnfStatement stmtsep  */
#line 1799 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-1].text);
			}
#line 3692 "parser-sming.c"
    break;

  case 143: /* abnfStatement: abnfKeyword sep text optsep ';'  */
#line 1805 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 3700 "parser-sming.c"
    break;

  case 144: /* refinedBaseType_refinedType: refinedBaseType  */
#line 1813 "parser-sming.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 3708 "parser-sming.c"
    break;

  case 145: /* refinedBaseType_refinedType: refinedType  */
#line 1817 "parser-sming.y"
                        {
			    (yyval.typePtr) = (yyvsp[0].typePtr);
			}
#line 3716 "parser-sming.c"
    break;

  case 146: /* attribute_refinedBaseType_refinedType: attribute_refinedBaseType  */
#line 1823 "parser-sming.y"
                        {
			    (yyval.attributePtr) = (yyvsp[0].attributePtr);
			}
#line 3724 "parser-sming.c"
    break;

  case 147: /* attribute_refinedBaseType_refinedType: attribute_refinedType  */
#line 1827 "parser-sming.y"
                        {
			    (yyval.attributePtr) = (yyvsp[0].attributePtr);
			}
#line 3732 "parser-sming.c"
    break;

  case 148: /* refinedBaseType: OctetStringKeyword optsep_numberSpec_01  */
#line 1834 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeOctetStringPtr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeOctetStringPtr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeOctetStringPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3751 "parser-sming.c"
    break;

  case 149: /* refinedBaseType: ObjectIdentifierKeyword  */
#line 1849 "parser-sming.y"
                        {
			    (yyval.typePtr) = smiHandle->typeObjectIdentifierPtr;
			}
#line 3759 "parser-sming.c"
    break;

  case 150: /* refinedBaseType: Integer32Keyword optsep_numberSpec_01  */
#line 1853 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeInteger32Ptr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeInteger32Ptr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeInteger32Ptr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3778 "parser-sming.c"
    break;

  case 151: /* refinedBaseType: Unsigned32Keyword optsep_numberSpec_01  */
#line 1868 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeUnsigned32Ptr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeUnsigned32Ptr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeUnsigned32Ptr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3797 "parser-sming.c"
    break;

  case 152: /* refinedBaseType: Integer64Keyword optsep_numberSpec_01  */
#line 1883 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeInteger64Ptr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeInteger64Ptr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeInteger64Ptr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3816 "parser-sming.c"
    break;

  case 153: /* refinedBaseType: Unsigned64Keyword optsep_numberSpec_01  */
#line 1898 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeUnsigned64Ptr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeUnsigned64Ptr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeUnsigned64Ptr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3835 "parser-sming.c"
    break;

  case 154: /* refinedBaseType: Float32Keyword optsep_floatSpec_01  */
#line 1913 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeFloat32Ptr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeFloat32Ptr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeFloat32Ptr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3854 "parser-sming.c"
    break;

  case 155: /* refinedBaseType: Float64Keyword optsep_floatSpec_01  */
#line 1928 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeFloat64Ptr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeFloat64Ptr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeFloat64Ptr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3873 "parser-sming.c"
    break;

  case 156: /* refinedBaseType: Float128Keyword optsep_floatSpec_01  */
#line 1943 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeFloat128Ptr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeFloat128Ptr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeFloat128Ptr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3892 "parser-sming.c"
    break;

  case 157: /* refinedBaseType: PointerKeyword optsep_pointerRestr_01  */
#line 1958 "parser-sming.y"
                        {
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typePointerPtr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typePointerPtr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typePointerPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));				
				}
			}
#line 3907 "parser-sming.c"
    break;

  case 158: /* refinedBaseType: EnumerationKeyword bitsOrEnumerationSpec  */
#line 1969 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeEnumPtr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeEnumPtr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeEnumPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			}
#line 3926 "parser-sming.c"
    break;

  case 159: /* $@45: %empty  */
#line 1984 "parser-sming.y"
                        {
				bitsFlag = 1; //Since Enum elements can be 
							  //negative we must make sure
							  //that bits is not negative,
							  //so we raise bitsFlag and
							  //give error if there is
							  //negative value 
			}
#line 3939 "parser-sming.c"
    break;

  case 160: /* refinedBaseType: BitsKeyword $@45 bitsOrEnumerationSpec  */
#line 1993 "parser-sming.y"
                        {
			    List *p;
			    
			    if (!(yyvsp[0].listPtr)) {
				(yyval.typePtr) = smiHandle->typeBitsPtr;
			    } else {
				(yyval.typePtr) = duplicateType(smiHandle->typeBitsPtr, 0,
						   thisParserPtr);
				setTypeParent((yyval.typePtr), smiHandle->typeBitsPtr);
				setTypeList((yyval.typePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((NamedNumber *)p->ptr)->typePtr = (yyval.typePtr);
			    }
			    
			    bitsFlag = 0;//reset flag
			}
#line 3960 "parser-sming.c"
    break;

  case 161: /* attribute_refinedBaseType: OctetStringKeyword optsep_numberSpec_01  */
#line 2013 "parser-sming.y"
                        {
			    List *p;
			    (yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeOctetStringPtr,
												classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeOctetStringPtr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 3976 "parser-sming.c"
    break;

  case 162: /* attribute_refinedBaseType: ObjectIdentifierKeyword  */
#line 2025 "parser-sming.y"
                        {
			    (yyval.attributePtr) = duplicateTypeToAttribute(
			    	smiHandle->typeObjectIdentifierPtr, classPtr, thisParserPtr);
			   	setAttributeParentType((yyval.attributePtr), smiHandle->typeObjectIdentifierPtr);
			}
#line 3986 "parser-sming.c"
    break;

  case 163: /* attribute_refinedBaseType: Integer32Keyword optsep_numberSpec_01  */
#line 2031 "parser-sming.y"
                        {
			    List *p;
			    
				(yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeInteger32Ptr,
													classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeInteger32Ptr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4003 "parser-sming.c"
    break;

  case 164: /* attribute_refinedBaseType: Unsigned32Keyword optsep_numberSpec_01  */
#line 2044 "parser-sming.y"
                        {
			    List *p;
			    
				(yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeUnsigned32Ptr,
													classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeUnsigned32Ptr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4020 "parser-sming.c"
    break;

  case 165: /* attribute_refinedBaseType: Integer64Keyword optsep_numberSpec_01  */
#line 2057 "parser-sming.y"
                        {
			   List *p;
			    
				(yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeInteger64Ptr,
													classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeInteger64Ptr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4037 "parser-sming.c"
    break;

  case 166: /* attribute_refinedBaseType: Unsigned64Keyword optsep_numberSpec_01  */
#line 2070 "parser-sming.y"
                        {
			   List *p;
			    
				(yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeUnsigned64Ptr,
													classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeUnsigned64Ptr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4054 "parser-sming.c"
    break;

  case 167: /* attribute_refinedBaseType: Float32Keyword optsep_floatSpec_01  */
#line 2083 "parser-sming.y"
                        {
			    List *p;
			    
				(yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeFloat32Ptr,
													classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeFloat32Ptr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4071 "parser-sming.c"
    break;

  case 168: /* attribute_refinedBaseType: Float64Keyword optsep_floatSpec_01  */
#line 2096 "parser-sming.y"
                        {
			   List *p;
			    
				(yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeFloat64Ptr,
													classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeFloat64Ptr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4088 "parser-sming.c"
    break;

  case 169: /* attribute_refinedBaseType: Float128Keyword optsep_floatSpec_01  */
#line 2109 "parser-sming.y"
                        {
			    List *p;
			    
			    (yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeFloat128Ptr,
							  classPtr, thisParserPtr);
			    setAttributeParentType((yyval.attributePtr), smiHandle->typeFloat128Ptr);
			    if ((yyvsp[0].listPtr)) {
				setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
				for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    ((Range *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4105 "parser-sming.c"
    break;

  case 170: /* attribute_refinedBaseType: PointerKeyword optsep_pointerRestr_01  */
#line 2122 "parser-sming.y"
                        {
			    (yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typePointerPtr,
							  classPtr, thisParserPtr);
			    setAttributeParentType((yyval.attributePtr), smiHandle->typePointerPtr);
			    if ((yyvsp[0].listPtr)) {
				setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
			    }
			}
#line 4118 "parser-sming.c"
    break;

  case 171: /* attribute_refinedBaseType: EnumerationKeyword bitsOrEnumerationSpec  */
#line 2131 "parser-sming.y"
                        {
			    List *p;
			    
			    (yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeEnumPtr,
													classPtr, thisParserPtr);
				setAttributeParentType((yyval.attributePtr), smiHandle->typeEnumPtr);
			    if ((yyvsp[0].listPtr)) {
					setAttributeList((yyval.attributePtr), (yyvsp[0].listPtr));
					for (p = (yyvsp[0].listPtr); p; p = p->nextPtr)
				    	((NamedNumber *)p->ptr)->typePtr = (Type*)(yyval.attributePtr);
			    }
			}
#line 4135 "parser-sming.c"
    break;

  case 172: /* $@46: %empty  */
#line 2144 "parser-sming.y"
                        {
				bitsFlag = 1; //Since Enum elements can be 
							  //negative we must make sure
							  //that bits is not negative,
							  //so we raise bitsFlag and
							  //give error if there is
							  //negative value 
			}
#line 4148 "parser-sming.c"
    break;

  case 173: /* attribute_refinedBaseType: BitsKeyword $@46 bitsOrEnumerationSpec  */
#line 2153 "parser-sming.y"
                        {
			    List *p;
			    
			    (yyval.attributePtr) = duplicateTypeToAttribute(smiHandle->typeBitsPtr,
							  classPtr, thisParserPtr);
			    setAttributeParentType((yyval.attributePtr), smiHandle->typeBitsPtr);
			    if ((yyvsp[-2].rc)) {
				setAttributeList((yyval.attributePtr), (void *)(yyvsp[-2].rc));
				for (p = (void *)(yyvsp[-2].rc); p; p = (void *)p->nextPtr)
				    ((NamedNumber *)(p->ptr))->typePtr = (Type*)(yyval.attributePtr);
			    }
			    
			    bitsFlag = 0; /* reset flag */
			}
#line 4167 "parser-sming.c"
    break;

  case 174: /* refinedType: qucIdentifier optsep_anySpec_01  */
#line 2170 "parser-sming.y"
                        {
			    typePtr = findType((yyvsp[-1].text), thisParserPtr,
					       thisModulePtr);
			    if (typePtr && (yyvsp[0].listPtr)) {
				typePtr = duplicateType(typePtr, 0,
							thisParserPtr);
				setTypeList(typePtr, (yyvsp[0].listPtr));
			    }

			    (yyval.typePtr) = typePtr;
			}
#line 4183 "parser-sming.c"
    break;

  case 175: /* attribute_refinedType: qucIdentifier optsep_anySpec_01  */
#line 2184 "parser-sming.y"
                        {
			    Class *tmp;
			    typePtr = findType((yyvsp[-1].text), thisParserPtr,
					       thisModulePtr);
			    if (typePtr && (yyvsp[0].listPtr)) {
				attributePtr = duplicateTypeToAttribute(typePtr,
											classPtr, thisParserPtr);
				setAttributeList(attributePtr, (yyvsp[0].listPtr));
				setAttributeParentType(attributePtr, typePtr);
			    } else if( typePtr ){
			    	attributePtr = duplicateTypeToAttribute(typePtr,
											classPtr, thisParserPtr);
					setAttributeParentType(attributePtr, typePtr);
				} else if((yyvsp[0].listPtr)){
					smiPrintError(thisParserPtr, ERR_UNKNOWN_TYPE, (yyvsp[-1].text));
					attributePtr = NULL;
				} else if (tmp = findClass((yyvsp[-1].text),
										 thisParserPtr,thisModulePtr)){
					attributePtr = addAttribute((yyvsp[-1].text), classPtr, thisParserPtr);
					setAttributeParentClass(attributePtr, tmp);
				} else {
					attributePtr = NULL;
					smiPrintError(thisParserPtr, 
											ERR_UNKNOWN_TYPE_OR_CLASS, (yyvsp[-1].text));
				}
				

			    (yyval.attributePtr) = attributePtr;
			}
#line 4217 "parser-sming.c"
    break;

  case 176: /* optsep_anySpec_01: %empty  */
#line 2216 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4225 "parser-sming.c"
    break;

  case 177: /* optsep_anySpec_01: optsep anySpec  */
#line 2220 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4233 "parser-sming.c"
    break;

  case 178: /* anySpec: numberSpec  */
#line 2226 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4241 "parser-sming.c"
    break;

  case 179: /* anySpec: floatSpec  */
#line 2230 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4249 "parser-sming.c"
    break;

  case 180: /* optsep_numberSpec_01: %empty  */
#line 2236 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4257 "parser-sming.c"
    break;

  case 181: /* optsep_numberSpec_01: optsep numberSpec  */
#line 2240 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4265 "parser-sming.c"
    break;

  case 182: /* numberSpec: '(' optsep numberElement furtherNumberElement_0n optsep ')'  */
#line 2247 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[-3].rangePtr);
			    (yyval.listPtr)->nextPtr = (yyvsp[-2].listPtr);
			}
#line 4275 "parser-sming.c"
    break;

  case 183: /* furtherNumberElement_0n: %empty  */
#line 2255 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4283 "parser-sming.c"
    break;

  case 184: /* furtherNumberElement_0n: furtherNumberElement_1n  */
#line 2259 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4291 "parser-sming.c"
    break;

  case 185: /* furtherNumberElement_1n: furtherNumberElement  */
#line 2265 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].rangePtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4301 "parser-sming.c"
    break;

  case 186: /* furtherNumberElement_1n: furtherNumberElement_1n furtherNumberElement  */
#line 2271 "parser-sming.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].rangePtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-1].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 4316 "parser-sming.c"
    break;

  case 187: /* furtherNumberElement: optsep '|' optsep numberElement  */
#line 2284 "parser-sming.y"
                        {
			    (yyval.rangePtr) = (yyvsp[0].rangePtr);
			}
#line 4324 "parser-sming.c"
    break;

  case 188: /* numberElement: signedNumber numberUpperLimit_01  */
#line 2290 "parser-sming.y"
                        {
			    (yyval.rangePtr) = smiMalloc(sizeof(Range));
			    (yyval.rangePtr)->export.minValue = *(yyvsp[-1].valuePtr);
			    if ((yyvsp[0].valuePtr)) {
				(yyval.rangePtr)->export.maxValue = *(yyvsp[0].valuePtr);
				smiFree((yyvsp[0].valuePtr));
			    } else {
				(yyval.rangePtr)->export.maxValue = *(yyvsp[-1].valuePtr);
			    }
			    smiFree((yyvsp[-1].valuePtr));
			}
#line 4340 "parser-sming.c"
    break;

  case 189: /* numberUpperLimit_01: %empty  */
#line 2304 "parser-sming.y"
                        {
			    (yyval.valuePtr) = NULL;
			}
#line 4348 "parser-sming.c"
    break;

  case 190: /* numberUpperLimit_01: numberUpperLimit  */
#line 2308 "parser-sming.y"
                        {
			    (yyval.valuePtr) = (yyvsp[0].valuePtr);
			}
#line 4356 "parser-sming.c"
    break;

  case 191: /* numberUpperLimit: optsep DOT_DOT optsep signedNumber  */
#line 2314 "parser-sming.y"
                        {
			    (yyval.valuePtr) = (yyvsp[0].valuePtr);
			}
#line 4364 "parser-sming.c"
    break;

  case 192: /* optsep_floatSpec_01: %empty  */
#line 2320 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4372 "parser-sming.c"
    break;

  case 193: /* optsep_floatSpec_01: optsep floatSpec  */
#line 2324 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4380 "parser-sming.c"
    break;

  case 194: /* floatSpec: '(' optsep floatElement furtherFloatElement_0n optsep ')'  */
#line 2331 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[-3].rangePtr);
			    (yyval.listPtr)->nextPtr = (yyvsp[-2].listPtr);
			}
#line 4390 "parser-sming.c"
    break;

  case 195: /* furtherFloatElement_0n: %empty  */
#line 2339 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4398 "parser-sming.c"
    break;

  case 196: /* furtherFloatElement_0n: furtherFloatElement_1n  */
#line 2343 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4406 "parser-sming.c"
    break;

  case 197: /* furtherFloatElement_1n: furtherFloatElement  */
#line 2349 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].rangePtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4416 "parser-sming.c"
    break;

  case 198: /* furtherFloatElement_1n: furtherFloatElement_1n furtherFloatElement  */
#line 2355 "parser-sming.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].rangePtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-1].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 4431 "parser-sming.c"
    break;

  case 199: /* furtherFloatElement: optsep '|' optsep floatElement  */
#line 2368 "parser-sming.y"
                        {
			    (yyval.rangePtr) = (yyvsp[0].rangePtr);
			}
#line 4439 "parser-sming.c"
    break;

  case 200: /* floatElement: floatValue floatUpperLimit_01  */
#line 2374 "parser-sming.y"
                        {
			    (yyval.rangePtr) = smiMalloc(sizeof(Range));
			    (yyval.rangePtr)->export.minValue.basetype = SMI_BASETYPE_FLOAT64;
			    (yyval.rangePtr)->export.minValue.value.float64 = strtod((yyvsp[-1].text), NULL);
			    if ((yyvsp[0].text)) {
				(yyval.rangePtr)->export.maxValue.basetype =
				                          SMI_BASETYPE_FLOAT64;
				(yyval.rangePtr)->export.maxValue.value.float64 =
				                              strtod((yyvsp[0].text), NULL);
			    } else {
				(yyval.rangePtr)->export.maxValue = (yyval.rangePtr)->export.minValue;
			    }
			}
#line 4457 "parser-sming.c"
    break;

  case 201: /* floatUpperLimit_01: %empty  */
#line 2390 "parser-sming.y"
                        {
			    (yyval.text) = NULL;
			}
#line 4465 "parser-sming.c"
    break;

  case 202: /* floatUpperLimit_01: floatUpperLimit  */
#line 2394 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4473 "parser-sming.c"
    break;

  case 203: /* floatUpperLimit: optsep DOT_DOT optsep floatValue  */
#line 2400 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4481 "parser-sming.c"
    break;

  case 204: /* specialFloatValue: neginfKeyword  */
#line 2407 "parser-sming.y"
                        {
				(yyval.text)="-inf";
			}
#line 4489 "parser-sming.c"
    break;

  case 205: /* specialFloatValue: posinfKeyword  */
#line 2411 "parser-sming.y"
                        {
				(yyval.text)="+inf";
			}
#line 4497 "parser-sming.c"
    break;

  case 206: /* specialFloatValue: qnanKeyword  */
#line 2415 "parser-sming.y"
                        {
				(yyval.text)="nan";
			}
#line 4505 "parser-sming.c"
    break;

  case 207: /* specialFloatValue: snanKeyword  */
#line 2419 "parser-sming.y"
                        {
				(yyval.text)="nan";
			}
#line 4513 "parser-sming.c"
    break;

  case 208: /* optsep_pointerRestr_01: %empty  */
#line 2425 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4521 "parser-sming.c"
    break;

  case 209: /* optsep_pointerRestr_01: optsep pointerRestr  */
#line 2429 "parser-sming.y"
                        {
			    NamedNumber *nn =(NamedNumber*)smiMalloc(sizeof(NamedNumber));
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = nn;
			    nn->export.name = (yyvsp[0].text);
			}
#line 4532 "parser-sming.c"
    break;

  case 210: /* pointerRestr: '(' optsep qlcIdentifier optsep ')'  */
#line 2438 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[-2].text);
			}
#line 4540 "parser-sming.c"
    break;

  case 211: /* bitsOrEnumerationSpec: '(' optsep bitsOrEnumerationList optsep ')'  */
#line 2444 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 4548 "parser-sming.c"
    break;

  case 212: /* bitsOrEnumerationList: bitsOrEnumerationItem furtherBitsOrEnumerationItem_0n optsep_comma_01  */
#line 2451 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[-2].namedNumberPtr);
			    (yyval.listPtr)->nextPtr = (yyvsp[-1].listPtr);
			}
#line 4558 "parser-sming.c"
    break;

  case 213: /* furtherBitsOrEnumerationItem_0n: %empty  */
#line 2459 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4566 "parser-sming.c"
    break;

  case 214: /* furtherBitsOrEnumerationItem_0n: furtherBitsOrEnumerationItem_1n  */
#line 2463 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4574 "parser-sming.c"
    break;

  case 215: /* furtherBitsOrEnumerationItem_1n: furtherBitsOrEnumerationItem  */
#line 2469 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].namedNumberPtr);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4584 "parser-sming.c"
    break;

  case 216: /* furtherBitsOrEnumerationItem_1n: furtherBitsOrEnumerationItem_1n furtherBitsOrEnumerationItem  */
#line 2476 "parser-sming.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].namedNumberPtr);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-1].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 4599 "parser-sming.c"
    break;

  case 217: /* furtherBitsOrEnumerationItem: optsep ',' optsep bitsOrEnumerationItem  */
#line 2490 "parser-sming.y"
                        {
			    (yyval.namedNumberPtr) = (yyvsp[0].namedNumberPtr);
			}
#line 4607 "parser-sming.c"
    break;

  case 218: /* bitsOrEnumerationItem: lcIdentifier optsep '(' optsep signedNumber optsep ')'  */
#line 2496 "parser-sming.y"
                        {
			    (yyval.namedNumberPtr) = smiMalloc(sizeof(NamedNumber));
			    (yyval.namedNumberPtr)->export.name = (yyvsp[-6].text);
			    (yyval.namedNumberPtr)->export.value = *(yyvsp[-2].valuePtr);
			}
#line 4617 "parser-sming.c"
    break;

  case 219: /* identifierList: identifier furtherIdentifier_0n optsep_comma_01  */
#line 2504 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[-2].text);
			    (yyval.listPtr)->nextPtr = (yyvsp[-1].listPtr);
			}
#line 4627 "parser-sming.c"
    break;

  case 220: /* furtherIdentifier_0n: %empty  */
#line 2512 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4635 "parser-sming.c"
    break;

  case 221: /* furtherIdentifier_0n: furtherIdentifier_1n  */
#line 2516 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4643 "parser-sming.c"
    break;

  case 222: /* furtherIdentifier_1n: furtherIdentifier  */
#line 2522 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].text);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4653 "parser-sming.c"
    break;

  case 223: /* furtherIdentifier_1n: furtherIdentifier_1n furtherIdentifier  */
#line 2528 "parser-sming.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].text);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-1].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 4668 "parser-sming.c"
    break;

  case 224: /* furtherIdentifier: optsep ',' optsep identifier  */
#line 2541 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4676 "parser-sming.c"
    break;

  case 225: /* bitsValue: '(' optsep bitsList optsep ')'  */
#line 2547 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[-2].listPtr);
			}
#line 4684 "parser-sming.c"
    break;

  case 226: /* bitsList: optsep_comma_01  */
#line 2553 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4692 "parser-sming.c"
    break;

  case 227: /* bitsList: lcIdentifier furtherLcIdentifier_0n optsep_comma_01  */
#line 2557 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[-2].text);
			    (yyval.listPtr)->nextPtr = (yyvsp[-1].listPtr);
			}
#line 4702 "parser-sming.c"
    break;

  case 228: /* furtherLcIdentifier_0n: %empty  */
#line 2566 "parser-sming.y"
                        {
			    (yyval.listPtr) = NULL;
			}
#line 4710 "parser-sming.c"
    break;

  case 229: /* furtherLcIdentifier_0n: furtherLcIdentifier_1n  */
#line 2570 "parser-sming.y"
                        {
			    (yyval.listPtr) = (yyvsp[0].listPtr);
			}
#line 4718 "parser-sming.c"
    break;

  case 230: /* furtherLcIdentifier_1n: furtherLcIdentifier  */
#line 2576 "parser-sming.y"
                        {
			    (yyval.listPtr) = smiMalloc(sizeof(List));
			    (yyval.listPtr)->ptr = (yyvsp[0].text);
			    (yyval.listPtr)->nextPtr = NULL;
			}
#line 4728 "parser-sming.c"
    break;

  case 231: /* furtherLcIdentifier_1n: furtherLcIdentifier_1n furtherLcIdentifier  */
#line 2582 "parser-sming.y"
                        {
			    List *p, *pp;
			    
			    p = smiMalloc(sizeof(List));
			    p->ptr = (yyvsp[0].text);
			    p->nextPtr = NULL;
			    for (pp = (yyvsp[-1].listPtr); pp->nextPtr; pp = pp->nextPtr);
			    pp->nextPtr = p;
			    (yyval.listPtr) = (yyvsp[-1].listPtr);
			}
#line 4743 "parser-sming.c"
    break;

  case 232: /* furtherLcIdentifier: optsep ',' optsep lcIdentifier  */
#line 2595 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4751 "parser-sming.c"
    break;

  case 233: /* identifier: ucIdentifier  */
#line 2601 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4759 "parser-sming.c"
    break;

  case 234: /* identifier: lcIdentifier  */
#line 2605 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4767 "parser-sming.c"
    break;

  case 235: /* qucIdentifier: ucIdentifier COLON_COLON ucIdentifier  */
#line 2611 "parser-sming.y"
                        {
			    char *s;

			    s = smiMalloc(strlen((yyvsp[-2].text)) +
					    strlen((yyvsp[0].text)) + 3);
			    sprintf(s, "%s::%s", (yyvsp[-2].text), (yyvsp[0].text));
			    (yyval.text) = s;
			    free((yyvsp[-2].text));
			    free((yyvsp[0].text));
			}
#line 4782 "parser-sming.c"
    break;

  case 236: /* qucIdentifier: ucIdentifier  */
#line 2622 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4790 "parser-sming.c"
    break;

  case 237: /* qlcIdentifier: ucIdentifier COLON_COLON lcIdentifier  */
#line 2628 "parser-sming.y"
                        {
			    char *s;

			    s = smiMalloc(strlen((yyvsp[-2].text)) +
					  strlen((yyvsp[0].text)) + 3);
			    sprintf(s, "%s::%s", (yyvsp[-2].text), (yyvsp[0].text));
			    (yyval.text) = s;
			}
#line 4803 "parser-sming.c"
    break;

  case 238: /* qlcIdentifier: lcIdentifier  */
#line 2637 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4811 "parser-sming.c"
    break;

  case 239: /* text: textSegment optsep_textSegment_0n  */
#line 2643 "parser-sming.y"
                        {
			    int len;
			    if ((yyvsp[0].text)) {
				(yyval.text) = smiMalloc(strlen((yyvsp[-1].text)) + strlen((yyvsp[0].text)) + 1);
				strcpy((yyval.text), (yyvsp[-1].text));
				strcat((yyval.text), (yyvsp[0].text));
				free((yyvsp[-1].text));
				free((yyvsp[0].text));
			    } else {
				(yyval.text) = smiStrdup((yyvsp[-1].text));
			    }
			    len = strlen((yyval.text));
			    while (len > 0 && (yyval.text)[len-1] == '\n') {
				(yyval.text)[--len] = 0;
			    }
			}
#line 4832 "parser-sming.c"
    break;

  case 240: /* optsep_textSegment_0n: %empty  */
#line 2662 "parser-sming.y"
                        {
			    (yyval.text) = NULL;
			}
#line 4840 "parser-sming.c"
    break;

  case 241: /* optsep_textSegment_0n: optsep_textSegment_1n  */
#line 2666 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4848 "parser-sming.c"
    break;

  case 242: /* optsep_textSegment_1n: optsep_textSegment  */
#line 2672 "parser-sming.y"
                        {
			    (yyval.text) = (yyvsp[0].text);
			}
#line 4856 "parser-sming.c"
    break;

  case 243: /* optsep_textSegment_1n: optsep_textSegment_1n optsep_textSegment  */
#line 2676 "parser-sming.y"
                        {
			    (yyval.text) = smiMalloc(strlen((yyvsp[-1].text)) + strlen((yyvsp[0].text)) + 1);
			    strcpy((yyval.text), (yyvsp[-1].text));
			    strcat((yyval.text), (yyvsp[0].text));
			    free((yyvsp[-1].text));
			    free((yyvsp[0].text));
			}
#line 4868 "parser-sming.c"
    break;

  case 244: /* optsep_textSegment: optsep textSegment  */
#line 2686 "parser-sming.y"
                        {
			    (yyval.text) = smiStrdup((yyvsp[0].text));
			}
#line 4876 "parser-sming.c"
    break;

  case 245: /* date: textSegment  */
#line 2692 "parser-sming.y"
                        {
			    (yyval.date) = checkDate(thisParserPtr, (yyvsp[0].text));
			}
#line 4884 "parser-sming.c"
    break;

  case 246: /* format: textSegment  */
#line 2698 "parser-sming.y"
                        {
			    (yyval.text) = smiStrdup((yyvsp[0].text));
			}
#line 4892 "parser-sming.c"
    break;

  case 247: /* units: textSegment  */
#line 2704 "parser-sming.y"
                        {
			    (yyval.text) = smiStrdup((yyvsp[0].text));
			}
#line 4900 "parser-sming.c"
    break;

  case 248: /* anyValue: bitsValue  */
#line 2717 "parser-sming.y"
                        {
			    if (defaultBasetype == SMI_BASETYPE_BITS) {
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_BITS;
				(yyval.valuePtr)->value.ptr = (void*)((yyvsp[0].listPtr));
				//set the bits value in the value.integer32
				if(typePtr){
					createBitsValue((yyval.valuePtr),typePtr);
				}
				else if(attributePtr){
				createBitsValue((yyval.valuePtr),
					(Type*)smiGetAttributeParentType(&(attributePtr->export)));
				}
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
			    }
			}
#line 4924 "parser-sming.c"
    break;

  case 249: /* anyValue: decimalNumber  */
#line 2737 "parser-sming.y"
                        {
			    /* Note: might also be an OID or signed */
			    switch (defaultBasetype) {
			    case SMI_BASETYPE_UNSIGNED32:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 10);
				break;
			    case SMI_BASETYPE_UNSIGNED64:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
				(yyval.valuePtr)->value.unsigned64 = strtoull((yyvsp[0].text), NULL, 10);
				break;
			    case SMI_BASETYPE_INTEGER32:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
				(yyval.valuePtr)->value.integer32 = strtol((yyvsp[0].text), NULL, 10);
				break;
			    case SMI_BASETYPE_INTEGER64:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
				(yyval.valuePtr)->value.integer64 = strtoll((yyvsp[0].text), NULL, 10);
				break;
			    case SMI_BASETYPE_OBJECTIDENTIFIER:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OBJECTIDENTIFIER;
				(yyval.valuePtr)->len = strlen((yyvsp[0].text));
				(yyval.valuePtr)->value.ptr = smiStrdup((yyvsp[0].text));
				/* TODO */
				break;
			    default:
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
				break;
			    }
			}
#line 4966 "parser-sming.c"
    break;

  case 250: /* anyValue: '-' decimalNumber  */
#line 2775 "parser-sming.y"
                        {
			    switch (defaultBasetype) {
			    case SMI_BASETYPE_INTEGER32:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
				(yyval.valuePtr)->value.integer32 = - strtol((yyvsp[0].text), NULL, 10);
				break;
			    case SMI_BASETYPE_INTEGER64:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
				(yyval.valuePtr)->value.integer64 = - strtoll((yyvsp[0].text), NULL, 10);
				break;
			    default:
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
				break;
			    }
			}
#line 4990 "parser-sming.c"
    break;

  case 251: /* anyValue: hexadecimalNumber  */
#line 2795 "parser-sming.y"
                        {
			    /* Note: might also be an octet string */
			    switch (defaultBasetype) {
			    case SMI_BASETYPE_UNSIGNED32:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED32;
				(yyval.valuePtr)->value.unsigned32 = strtoul((yyvsp[0].text), NULL, 16);
				break;
			    case SMI_BASETYPE_UNSIGNED64:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
				(yyval.valuePtr)->value.unsigned64 = strtoull((yyvsp[0].text), NULL, 16);
				break;
			    case SMI_BASETYPE_INTEGER32:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER32;
				(yyval.valuePtr)->value.integer32 = strtol((yyvsp[0].text), NULL, 16);
				break;
			    case SMI_BASETYPE_INTEGER64:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
				(yyval.valuePtr)->value.integer64 = strtoll((yyvsp[0].text), NULL, 16);
				break;
			    case SMI_BASETYPE_OCTETSTRING:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				(yyval.valuePtr)->value.ptr = hexToStr((yyvsp[0].text),strlen((yyvsp[0].text)));
				(yyval.valuePtr)->len = strlen((yyval.valuePtr)->value.ptr);
				break;
			    default:
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
				break;
			    }
			}
#line 5031 "parser-sming.c"
    break;

  case 252: /* anyValue: floatValue  */
#line 2832 "parser-sming.y"
                        {
			    /* Note: might also be an OID */
			    switch (defaultBasetype) {
			    case SMI_BASETYPE_FLOAT32:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT32;
				(yyval.valuePtr)->value.float32 = strtof((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;
			    case SMI_BASETYPE_FLOAT64:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT64;
				(yyval.valuePtr)->value.float64 = strtod((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;
			    case SMI_BASETYPE_FLOAT128:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT128;
				(yyval.valuePtr)->value.float128 = strtold((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;		
			    case SMI_BASETYPE_OBJECTIDENTIFIER:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OBJECTIDENTIFIER;
				(yyval.valuePtr)->value.ptr = smiMalloc(strlen((yyvsp[0].text))+1);
				strcpy((yyval.valuePtr)->value.ptr,(yyvsp[0].text));
				(yyval.valuePtr)->len = strlen((yyval.valuePtr)->value.ptr);
				break;
			    default:
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
				break;
			    }
			}
#line 5083 "parser-sming.c"
    break;

  case 253: /* anyValue: '-' floatValue  */
#line 2880 "parser-sming.y"
                        {
		
			    switch (defaultBasetype) {
			    case SMI_BASETYPE_FLOAT32:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT32;
				(yyval.valuePtr)->value.float32 = - strtof((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;
			    case SMI_BASETYPE_FLOAT64:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT64;
				(yyval.valuePtr)->value.float64 = - strtof((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;
			    case SMI_BASETYPE_FLOAT128:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT128;
				(yyval.valuePtr)->value.float128 = - strtof((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;		
			    default:
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
				break;
			    }
			}
#line 5128 "parser-sming.c"
    break;

  case 254: /* anyValue: specialFloatValue  */
#line 2921 "parser-sming.y"
                        {
				  /* Note: might also be an OID */
			    switch (defaultBasetype) {
			    case SMI_BASETYPE_FLOAT32:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT32;
				(yyval.valuePtr)->value.float32 = strtof((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;
			    case SMI_BASETYPE_FLOAT64:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT64;
				(yyval.valuePtr)->value.float64 = strtod((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;
			    case SMI_BASETYPE_FLOAT128:
			    	(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_FLOAT128;
				(yyval.valuePtr)->value.float128 = strtold((yyvsp[0].text),NULL);
				if(errno == ERANGE){
					smiPrintError(thisParserPtr, 
					ERR_FLOAT_OVERFLOW, (yyvsp[0].text));
					errno = 0;
				}
				break;
				default:
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
				break;
			    }	
			}
#line 5173 "parser-sming.c"
    break;

  case 255: /* anyValue: text  */
#line 2962 "parser-sming.y"
                        {
			    if (defaultBasetype == SMI_BASETYPE_OCTETSTRING) {
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OCTETSTRING;
				(yyval.valuePtr)->value.ptr = (yyvsp[0].text);
				(yyval.valuePtr)->len = strlen((yyvsp[0].text));
			    } else {
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
			    }
			}
#line 5190 "parser-sming.c"
    break;

  case 256: /* anyValue: qlcIdentifier  */
#line 2975 "parser-sming.y"
                        {
			    /* Note: might be an Enumeration item or OID */
			    /* TODO: convert if it's an oid? */
			    switch (defaultBasetype) {
			    case SMI_BASETYPE_ENUM:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_ENUM;
				(yyval.valuePtr)->value.ptr = (yyvsp[0].text);
				(yyval.valuePtr)->len = strlen((yyvsp[0].text));
				/* TODO: XXX convert to int */
				break;
			    case SMI_BASETYPE_OBJECTIDENTIFIER:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OBJECTIDENTIFIER;
				(yyval.valuePtr)->value.ptr = (yyvsp[0].text);
				(yyval.valuePtr)->len = strlen((yyvsp[0].text));
				/* TODO: XXX convert to oid if found */
				break;
				case SMI_BASETYPE_POINTER:
				(yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OBJECTIDENTIFIER;
				(yyval.valuePtr)->value.ptr = (yyvsp[0].text);
				(yyval.valuePtr)->len = strlen((yyvsp[0].text));
				/* TODO: XXX check if valid reference found */
				break;
			    default:
				smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
				(yyval.valuePtr) = NULL;
				break;
			    }
			}
#line 5227 "parser-sming.c"
    break;

  case 257: /* anyValue: qOID  */
#line 3008 "parser-sming.y"
                        {
			    if (defaultBasetype == SMI_BASETYPE_OBJECTIDENTIFIER){
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
				(yyval.valuePtr)->basetype = SMI_BASETYPE_OBJECTIDENTIFIER;
				(yyval.valuePtr)->value.ptr = (yyvsp[0].text);
				(yyval.valuePtr)->len = strlen((yyval.valuePtr)->value.ptr);
			    }
			    else
			    	smiPrintError(thisParserPtr,
					      ERR_UNEXPECTED_VALUETYPE);
			}
#line 5243 "parser-sming.c"
    break;

  case 258: /* qOID: ucIdentifier COLON_COLON OID  */
#line 3022 "parser-sming.y"
                        {
			    char *s;

			    s = smiMalloc(strlen((yyvsp[-2].text)) +
					  strlen((yyvsp[0].text)) + 3);
			    sprintf(s, "%s::%s", (yyvsp[-2].text), (yyvsp[0].text));
			    (yyval.text) = s;
			}
#line 5256 "parser-sming.c"
    break;

  case 259: /* qOID: OID  */
#line 3031 "parser-sming.y"
                        {
				(yyval.text) = smiMalloc(strlen((yyvsp[0].text))+1);
				strcpy((yyval.text),(yyvsp[0].text));
			}
#line 5265 "parser-sming.c"
    break;

  case 260: /* status: currentKeyword  */
#line 3038 "parser-sming.y"
                        {
			    (yyval.status) = SMI_STATUS_CURRENT;
			}
#line 5273 "parser-sming.c"
    break;

  case 261: /* status: deprecatedKeyword  */
#line 3042 "parser-sming.y"
                        {
			    (yyval.status) = SMI_STATUS_DEPRECATED;
			}
#line 5281 "parser-sming.c"
    break;

  case 262: /* status: obsoleteKeyword  */
#line 3046 "parser-sming.y"
                        {
			    (yyval.status) = SMI_STATUS_OBSOLETE;
			}
#line 5289 "parser-sming.c"
    break;

  case 263: /* number: hexadecimalNumber  */
#line 3052 "parser-sming.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
			    (yyval.valuePtr)->value.unsigned64 = strtoull((yyvsp[0].text), NULL, 16);
			}
#line 5299 "parser-sming.c"
    break;

  case 264: /* number: decimalNumber  */
#line 3058 "parser-sming.y"
                        {
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_UNSIGNED64;
			    (yyval.valuePtr)->value.unsigned64 = strtoull((yyvsp[0].text), NULL, 10);
			}
#line 5309 "parser-sming.c"
    break;

  case 265: /* negativeNumber: '-' decimalNumber  */
#line 3066 "parser-sming.y"
                        {
			    if(bitsFlag){
			    smiPrintError(thisParserPtr,
					      ERR_BITS_NUMBER_NEGATIVE);
			    (yyval.valuePtr) = NULL;
			    }
			    (yyval.valuePtr) = smiMalloc(sizeof(SmiValue));
			    (yyval.valuePtr)->basetype = SMI_BASETYPE_INTEGER64;
			    (yyval.valuePtr)->value.integer64 = - strtoll((yyvsp[0].text), NULL, 10);
			}
#line 5324 "parser-sming.c"
    break;

  case 266: /* signedNumber: number  */
#line 3079 "parser-sming.y"
                        {
			    (yyval.valuePtr) = (yyvsp[0].valuePtr);
			}
#line 5332 "parser-sming.c"
    break;

  case 267: /* signedNumber: negativeNumber  */
#line 3083 "parser-sming.y"
                        {
			    (yyval.valuePtr) = (yyvsp[0].valuePtr);
			}
#line 5340 "parser-sming.c"
    break;

  case 268: /* optsep_comma_01: %empty  */
#line 3093 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 5348 "parser-sming.c"
    break;

  case 269: /* sep: %empty  */
#line 3100 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 5356 "parser-sming.c"
    break;

  case 270: /* optsep: %empty  */
#line 3106 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 5364 "parser-sming.c"
    break;

  case 271: /* stmtsep: %empty  */
#line 3112 "parser-sming.y"
                        {
			    (yyval.rc) = 0;
			}
#line 5372 "parser-sming.c"
    break;


#line 5376 "parser-sming.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (parserPtr, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parserPtr);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, parserPtr);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (parserPtr, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parserPtr);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, parserPtr);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 3117 "parser-sming.y"


#endif
			
